var g_zpoolname = "",
  g_zfilesyssname = "";

function getzpoolsinfo(info) {
  jQuery('#jv-zfspoolhost').empty();
  for (var i = 0; i < info.length; i++) {
    var tp_ = info[i];
    var zfilesyss = tp_.zfilesyss || [];
    var pooldom = zfsTemplateAppend('#jv-zfspoolhost', 'jvt-zfspooldatasetitem', 'jvt-zfspooldatasetitem-' + i);
    pooldom.find('.poolname').text(tp_.name || '--');
    if (i == 0) {
      pooldom.find('.pool-c').removeClass('pool-o');
      pooldom.find('.datasetlist').show();
    } else {
      pooldom.find('.pool-c').addClass('pool-o');
      pooldom.find('.datasetlist').hide();
    }

    for (var j = 0; j < zfilesyss.length; j++) {
      var td_ = zfilesyss[j];
      var ddom = zfsTemplateAppend(pooldom.find('.datasetlist'), 'jvt-zfsdatasetitem', 'jvt-zfsdatasetitem-' + i + j);
      ddom.find('.datasetname').text(td_.name || '--');
      ddom.attr('encryption', td_.encryption);
      if (td_.type == "volume") {
        ddom.find('.datasetname').addClass('zvolname').removeClass('datasetnameicon');
      } else {
        ddom.find('.datasetname').addClass('datasetnameicon').removeClass('zvolname');
      }
      if (j == 0 && i == 0) {
        ddom.addClass('nv_hover');
        getsnapshotinfo(tp_.name, td_.name);
      }
      ddom.on('click', function() {
        var pnode = jQuery(this).closest('div.pool-datase-titem');
        jQuery('.zfsdatasetitem').removeClass('nv_hover');
        jQuery(this).addClass('nv_hover');
        getsnapshotinfo(pnode.find('.poolname').text(), jQuery(this).find('.datasetname ').text());
      })
    }
  }
}

function getsnapshotinfo(zpoolname, zfilesyssname) {
  g_zpoolname = zpoolname;
  g_zfilesyssname = zfilesyssname;
  zfs_manager_waiting_show();
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'zfs_snapshot_info',
      params: {
        "zpool": zpoolname,
        "zfilesys": zfilesyssname
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      var snapshotlist = info.data || [];
      jQuery('#jv-bdrsnapshots').empty();
      jQuery('#jv-repsnapshot-selectall').prop('checked', false);
      var f = snapshotlist.length - 1;
      for (var i = f; i >= 0; i--) {
        var tp_ = snapshotlist[i];
        var zfilesys_status = false;
        var s_dom = zfsTemplateAppend('#jv-bdrsnapshots', 'jvt-bdrsnapitem', 'jvt-bdrsnapitem-' + i);
        s_dom.find('.snapname').text(tp_.name || '--');
        s_dom.find('.jvc-creation').text(formatDate(tp_.creation));

        s_dom.data('info', tp_);
        s_dom.attr('snap', tp_.name).attr('zfilesys', zfilesyssname).attr('zpool', zpoolname).
        attr('oldshare', (zfilesys_status ? 'yes' : 'no')).attr('tag', tp_.tags).attr('mounted', tp_.mounted);
        s_dom.find('input[type=checkbox]').on('click', function() {
          var s_len = jQuery('#jv-bdrsnapshots').children().length;
          var ck_len = jQuery('#jv-bdrsnapshots input[type=checkbox]:checked').length;
          if (s_len == ck_len) {
            jQuery('#jv-repsnapshot-selectall').prop('checked', true);
          } else {
            jQuery('#jv-repsnapshot-selectall').prop('checked', false);
          }
          if (ck_len) {
            jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content');
          } else {
            jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content_disabled');
          }
        })

        seteChart(s_dom.find('.jvc-cupUsageEC')[0], 0, '#08cea1');

        if (tp_.mounted) {
          s_dom.find('.jvc-mounted').addClass('unmounticon').attr('title', '##$@zfs@$##Unmount##$@zfs@$##');
        } else {
          s_dom.find('.jvc-mounted').addClass('mounticon').attr('title', '##$@zfs@$##Mount##$@zfs@$##');
        }

        s_dom.find('.jvc-mounted').on('click', function() {
          var pnode = jQuery(this).closest('div.bdrsnapitem');
          zfszpool_submit_mount(pnode);
        })

        s_dom.find('.cloneicon').on('click', function() {
          var pnode = jQuery(this).closest('div.bdrsnapitem');
          zfszpool_submit_clone(pnode);
        })
        s_dom.find('.rollbackicon').on('click', function() {
          var pnode = jQuery(this).closest('div.bdrsnapitem');
          zfszpool_submit_rollback(pnode);
        })

        s_dom.find('.sendingicon').on('click', function() {
          var pnode = jQuery(this).closest('div.bdrsnapitem');
          zfszpool_submit_send(pnode);
        })

        s_dom.find('.deleteicon').on('click', function() {
          var pnode = jQuery(this).closest('div.bdrsnapitem');
          var info = pnode.data('info');

          unasConfirm({
            msg: "Are you sure to delete the snapshot?"
          }, function() {
            zfszpool_snapshot_rm(info);
          })
        })
      }
      zfsTranslator('jv-bdrsnapshots');
      zfspool_getSendProgress(g_zpoolname, g_zfilesyssname);
    },
    complete: function(xml) {
      zfs_manager_waiting_hide();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })

}

function formatDate(d) {
  if (!d) {
    return '--';
  }
  var date = new Date(d * 1000);
  var YY = date.getFullYear() + '-';
  var MM = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '-';
  var DD = (date.getDate() < 10 ? '0' + (date.getDate()) : date.getDate());
  var hh = (date.getHours() < 10 ? '0' + date.getHours() : date.getHours()) + ':';
  var mm = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes());
  var ss = (date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds());
  return YY + MM + DD + " " + hh + mm;
};
// Mount
function zfszpool_submit_mount(e, f) {

  var cmd = 'zfs_snapshot_umount';

  if (jQuery.isArray(e)) {
    var snap_name = jQuery(e[rm_i]).attr('snap');
    var share = jQuery(e[rm_i]).attr('oldshare');
    var zpool = jQuery(e[rm_i]).attr('zpool');
    var zfilesys = jQuery(e[rm_i]).attr('zfilesys');
    var mounted = jQuery(e[rm_i]).attr('mounted');
    if (mounted == 'false') {
      cmd = 'zfs_snapshot_mount';
    }
  } else {
    var snap_name = jQuery(e).attr('snap');
    var share = jQuery(e).attr('oldshare');
    var zpool = jQuery(e).attr('zpool');
    var zfilesys = jQuery(e).attr('zfilesys');
    var mounted = jQuery(e).attr('mounted');
    if (mounted == 'false') {
      cmd = 'zfs_snapshot_mount';
    }
  }
  var len = jQuery('#jv-bdrsnapshots input[type="checkbox"]:checked').length;

  var data = {
    cmd: cmd,
    params: {
      name: snap_name,
      zpool: zpool,
      zfilesys: zfilesys
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(data) {

      if (jQuery.isArray(e)) {
        rm_i++;
        if (rm_i < len) {
          zfszpool_submit_mount(pool_snapshot_rm, 1);
        } else {
          getsnapshotinfo(zpool, zfilesys);
          getZPOOLsInfo(zpool);
          rm_i = 0;
        }
      } else {
        if (f == undefined && !f) {
          getsnapshotinfo(zpool, zfilesys);
          getZPOOLsInfo(zpool);
        } else {

        }
      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function zfszpool_snapshot_mountS() {

  pool_snapshot_rm = [];
  jQuery('#jv-bdrsnapshots div.bdrsnapitem').each(function(i, e) {
    if (jQuery(e).find('input[type="checkbox"]').prop("checked")) {
      var that = jQuery(e).closest('div.bdrsnapitem');
      pool_snapshot_rm.push(that);
    }
  })

  zfszpool_submit_mount(pool_snapshot_rm, 1);
}

// Clone

function zfszpool_submit_clone(e) {

  var snap_name = jQuery(e).attr('snap');
  var share = jQuery(e).attr('oldshare');
  var zpool = jQuery(e).attr('zpool');
  var zfilesys = jQuery(e).attr('zfilesys');

  let data = {
    cmd: 'zfs_snapshot_clone',
    params: {
      name: snap_name,
      zpool: zpool,
      zfilesys: zfilesys
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: 'application/json',
    data: JSON.encode(data),
    timeout: 30000,
    success: function(data) {
      getsnapshotinfo(zpool, zfilesys);
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

// Rollback
function zfszpool_submit_rollback(e) {

  unasConfirm({
    msg: "Are you sure to rollback the snapshot? Current data will be lost!"
  }, function() {
    var snap_name = jQuery(e).attr('snap');
    var share = jQuery(e).attr('oldshare');
    var zpool = jQuery(e).attr('zpool');
    var zfilesys = jQuery(e).attr('zfilesys');
    let data = {
      cmd: 'zfs_snapshot_rollback',
      params: {
        name: snap_name,
        zpool: zpool,
        zfilesys: zfilesys
      }
    }
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 30000,
      success: function(data) {
        getsnapshotinfo(zpool, zfilesys);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })

}

//Send
function zfszpool_submit_send(e) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery(e).attr('zpool');
  var zfilesys = jQuery(e).attr('zfilesys');

  var sendSnapshotWindow = new MUI.Modal({
    id: 'jv-sendSnapshotWindow',
    title: window.top.UNAS._('##$@zfs@$##Send Snapshot##$@zfs@$##'),
    modal: true,
    width: 550,
    height: 380,
    data: {
      snap_name: snap_name,
      zpool: zpool,
      zfilesys: zfilesys
    },
    modalOverlayClose: false,
    contentURL: '/apps/zfs/send_snapshot.html?v=0.0.1',
  });
  sendSnapshotWindow.callBack = function() {
    getsnapshotinfo(zpool, zfilesys);
  }
}


function zfspool_getSendProgress(zpool, zfilesys) {
  clearTimeout(zfspool_send_tiem);
  let data = {
    cmd: 'zfs_snapshot_info',
    params: {
      "zpool": zpool,
      "zfilesys": zfilesys
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 3000000,
    success: function(result) {
      var info = result.results;
      var running = info.running || {};
      var send_data = running.send || [];

      if (send_data.length) {
        jQuery('#jv-bdrsnapshots div.bdrsnapitem').each(function(i, e) {
          for (var k = 0; k < send_data.length; k++) {
            var send_info = send_data[k];
            if (send_info.snapshot == jQuery(e).find('.snapname').text()) {
              var p = send_info.progress.percent * 100 || 0;
              if (p > 100) {
                p = 99;
              }
              jQuery(e).find('.jvc-cupUsageEC').show();
              jQuery(e).find('.sendingicon').hide();
              seteChart(jQuery(e).find('.jvc-cupUsageEC')[0], parseInt(p), '#08cea1');
              break;
            } else {
              jQuery(e).find('.jvc-cupUsageEC').hide();
              jQuery(e).find('.sendingicon').show();
            }
          }
        })
      } else {
        jQuery('.jvc-cupUsageEC').hide();
        jQuery('.sendingicon').show();
      }

      if (send_data.length) {
        zfspool_send_tiem = setTimeout(function() {
          zfspool_getSendProgress(g_zpoolname, g_zfilesyssname);
        }, 2000);
      } else {
        clearTimeout(zfspool_send_tiem);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}

function afspool_snapshot_sendS(e) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery(e).attr('zpool');
  var zfilesys = jQuery(e).attr('zfilesys');

  var sendSnapshotWindow = new MUI.Modal({
    id: 'jv-sendSnapshotWindow',
    title: window.top.UNAS._('##$@zfs@$##Send Snapshot##$@zfs@$##'),
    modal: true,
    width: 550,
    height: 380,
    data: {
      type: 'zfspoollist'
    },
    modalOverlayClose: false,
    contentURL: '/apps/zfs/send_snapshot.html?v=0.0.1',
  });
  sendSnapshotWindow.callBack = function() {
    getsnapshotinfo(g_zpoolname, g_zfilesyssname);
  }
}

// delete
function zfszpool_snapshot_rm(e) {
  var snapshots = [];
  var c_n = jQuery('#jv-zfspoolhost div.nv_hover');
  var p_n = c_n.closest('div.pool-datase-titem');
  var zpool = p_n.find('.poolname').text();
  var zfilesys = c_n.find('.datasetname').text();

  if (jQuery.isArray(e)) {
    for (var i = 0; i < e.length; i++) {
      snapshots.push([zpool, zfilesys, e[i].name]);
    }
  } else {
    snapshots = [
      [zpool, zfilesys, e.name]
    ];
  }

  var len = jQuery('#jv-bdrsnapshots input[type="checkbox"]:checked').length;
  let data = {
    cmd: 'zfs_snapshot_rm',
    params: {
      snapshots: snapshots
    }
  }

  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(data) {
      getsnapshotinfo(zpool, zfilesys);
    },
    complete: function() {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function zfszpool_snapshot_deleteS() {

  unasConfirm({
    msg: "Are you sure to delete the snapshot?"
  }, function() {
    pool_snapshot_rm = [];
    jQuery('#jv-bdrsnapshots div.bdrsnapitem').each(function(i, e) {
      if (jQuery(e).find('input[type="checkbox"]').prop("checked")) {
        var that = jQuery(e).closest('div.bdrsnapitem').data('info');
        pool_snapshot_rm.push(that);
      }
    })
    zfs_manager_waiting_show();
    zfszpool_snapshot_rm(pool_snapshot_rm);
  })

}
// /
function showdatasetlist_zfs() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  var pnode = that.closest('div.pool-datase-titem');
  that.toggleClass('pool-o');
  pnode.find('.datasetlist').slideToggle();
}

function autosnapshotWIN() {
  var autosnapshotW = new MUI.Modal({
    id: 'jv-autosnapshotWindow',
    title: UNAS._('##$@zfs@$##Auto snapshot settings##$@zfs@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 650,
    height: 450,
    contentURL: '/apps/zfs/bdr/autosnapshot.html?v=0.0.1&'
  });
}

jQuery(document).ready(function() {
  getzpoolsinfo(zpoolsinfo);

  jQuery('#jv-repsnapshot-selectall').on('click', function() {
    var s_len = jQuery('#jv-bdrsnapshots').children().length;
    if (this.checked && s_len) {
      jQuery('#jv-bdrsnapshots input[type="checkbox"]').prop('checked', true);
      jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content');
    } else {
      jQuery('#jv-bdrsnapshots input[type="checkbox"]').prop('checked', false);
      jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content_disabled');
    }
  })

  jQuery("#jv-zfspoollist, #jv-bdrsnapshotscontent").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

})
