<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_log_remove(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,pv}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !validString($request->params->pv) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:pv";
    }else{
        $zfs = \UNAS\Volume\Volume::CreateVolumeObject("zfs");
        $zpool = $request->params->zpool;
        $pv = dev_id($request->params->pv);

        $cmd = "sudo zpool remove $zpool $pv";
        exec($cmd, $content, $ret);

        if ($ret==0){
            exec("sudo zpool labelclear -f $pv"); //clear label
            ClearDisk($pv);
            $respond->err = ERR_SUCCEED;
        }else{
            $respond->err = ERR_FAILED;
            $respond->errmsg = implode(PHP_EOL, $content);
        }
    }
    return true;
}

//zfs labelclear does not work, use this one to clear all partitions.
function ClearDisk($d){
    exec("lsblk -np -o kname " . $d, $output, $ret);
    if($ret == 0){
        //loop
        foreach($output as $p){
            $output2=array();
            exec("sudo zpool labelclear -f " . $p, $output2, $ret2); //clear label of partition
        }
    }
}
$dev_id_list = [];
function dev_id(string $name){
    global $dev_id_list;
    if (empty($dev_id_list)){
        foreach (glob("/dev/disk/by-id/*") as $id_raw){
            if (is_link($id_raw)){
                $dev_id_list[basename(realpath($id_raw))] = basename($id_raw);
            }
        }
    }
    $devname = basename($name);
    if (isset($dev_id_list[$devname])){
        return $dev_id_list[$devname];
    }else{
        return $name;
    }
}
?>
