<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_pv_replace(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,pv_old,pv_new}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !validString($request->params->pv_old) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:pv_old";
    }else
    if ( !validString($request->params->pv_new) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:pv_new";
    }else{
        $zpool = $request->params->zpool;
        $pv_old = dev_id($request->params->pv_old);
        $pv_new = dev_id($request->params->pv_new);

        $cmd = "sudo zpool replace -f $zpool $pv_old $pv_new";
        exec($cmd, $content, $ret);

        if ($ret==0){
            if(strpos($pv_old, "/dev/") === false){ //labelclear must have /dev/ in the device name.
                $pv_old = "/dev/" . $pv_old;
            }
            exec("sudo zpool labelclear -f $pv_old"); //clear label
            ClearDisk($pv_old);
            $respond->err = ERR_SUCCEED;
        }else{
            $respond->err = ERR_FAILED;
            $respond->errmsg = implode(PHP_EOL, $content);
        }
    }
    return true;
}

//zfs labelclear does not work, use this one to clear all partitions.
function ClearDisk($d){
    exec("lsblk -np -o kname " . $d, $output, $ret);
    if($ret == 0){
        //loop
        foreach($output as $p){
            $output2=array();
            exec("sudo zpool labelclear -f " . $p, $output2, $ret2); //clear label of partition
        }
    }
}

$dev_id_list = [];
function dev_id(string $name){
    global $dev_id_list;
    if (empty($dev_id_list)){
        foreach (glob("/dev/disk/by-id/*") as $id_raw){
            if (is_link($id_raw)){
                $dev_id_list[basename(realpath($id_raw))] = basename($id_raw);
            }
        }
    }
    $devname = basename($name);
    if (isset($dev_id_list[$devname])){
        return $dev_id_list[$devname];
    }else{
        return $name;
    }
}
?>
