<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_scrub_set(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,setScrub}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !isset($request->params->setScrub) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:setScrub";
    }else{
        $zpool = $request->params->zpool;
        $setScrub = $request->params->setScrub;

        if ($setScrub){
            if ( !is_integer($request->params->hour) )
            {
                $respond->err    = ERR_PARAMS;
                $respond->errmsg = "缺少参数或参数内容错误:hour";
            }else
            if ( !is_integer($request->params->interval) )
            {
                $respond->err    = ERR_PARAMS;
                $respond->errmsg = "缺少参数或参数内容错误:interval";
            }else{
                $hour = $request->params->hour;
                $interval = $request->params->interval;

                // Remove old cron
                $cmd = sprintf(ZFS_CMD_SCRUB_RM, $zpool);
                exec($cmd);

                // 0 0 * * 0            every week
                // 0 0 8-14,22-28 * 6   every 2 weeks
                // 0 0 1 * *            every month
                switch ($interval){
                    case 0:
                        $time = "0 $hour * * 0";
                        break;
                    case 1:
                        $time = "0 $hour 8-14,22-28 * 6";
                        break;
                    case 2:
                        $time = "0 $hour 1 * *";
                        break;
                    default:
                        $time = "0 $hour * * 0";
                        break;
                }
                $cmd = sprintf(ZFS_CMD_SCRUB_SET, $time, $zpool);
                exec($cmd, $content, $ret);

                if ($ret==0){
                    $respond->err = ERR_SUCCEED;
                }else{
                    $respond->err = ERR_FAILED;
                    $respond->errmsg = implode(PHP_EOL, $content);
                }
            }
        }else{
            $cmd = sprintf(ZFS_CMD_SCRUB_RM, $zpool);
            exec($cmd, $content, $ret);

            if ($ret==0){
                $respond->err = ERR_SUCCEED;
            }else{
                $respond->err = ERR_FAILED;
                $respond->errmsg = implode(PHP_EOL, $content);
            }
        }
    }
    return true;
}

?>
