<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_snapshot_receive(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,zfilesys,snap_name}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !validString($request->params->snap_name) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:snap_name";
    }else{
        $zpool = $request->params->zpool;
        $zfilesys = validString($request->params->zfilesys) ? $request->params->zfilesys : "";
        $snap_name = $request->params->snap_name;
        $target = $zpool.($zfilesys ? "/$zfilesys" : "");

        $zfs_snapname = "$target@$snap_name";

        $task_name = md5("$zfs_snapname-$target");
        $tmp_file = sprintf(ZFS_FILE_RECEIVE_TMP, $task_name);

        $task_conf = [
            "name" => $task_name,
            "type" => "local",
            "target" => $target,
            "snap" => $snap_name,
        ];
        file_put_contents($tmp_file, json_encode($task_conf));

        $receive_cmd = sprintf(ZFS_CMD_SNAPSHOT_RECEIVE, $task_name);
        exec($receive_cmd);

        $respond->err = ERR_SUCCEED;
    }
    return true;
}
?>
