<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_snapshot_replicate(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,zfilesys,name,timing,sendto}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !validString($request->params->zfilesys) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfilesys";
    }else
    if ( !validString($request->params->name) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:name";
    }else
    if ( !((validString($request->params->timing) && count(explode(" ", trim($request->params->timing))) == 5) || $request->params->timing == 0) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:timing";
    }else
    if ( !validString($request->params->sendto) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:sendto";
    }else{
        $zpool = $request->params->zpool;
        $zfilesys = $request->params->zfilesys;
        $name = $request->params->name;
        $timing = $request->params->timing;
        $sendto = $request->params->sendto;

        $zfs_path = "$zpool/$zfilesys";

        $replicationTasksJson = array();
        if(file_exists(ZFS_FILE_REPLICATION)){
            $replicationTasksJson = json_decode(file_get_contents(ZFS_FILE_REPLICATION), true);
        }

        if (isset($replicationTasksJson[$name])){
            $respond->err = ERR_REDUPLICATED; // 9955
        }else{
            $replicationTasksJson[$name] = [
                "dataset" => $zfs_path,
                "SendToDir" => $sendto,
                "Timing" => $timing,
            ];
            file_put_contents(ZFS_FILE_REPLICATION, json_encode($replicationTasksJson));
            if ($timing == 0) {
                $cmd = sprintf("sudo systemctl start --no-block zfs-replicate@%s.service", $name);
                exec($cmd);
            } else {
                refresh_cron($replicationTasksJson);
            }
            $respond->err = ERR_SUCCEED;
        }
    }
    return true;
}

function refresh_cron($replicationTasksJson){
    $lines = [];
    foreach ($replicationTasksJson as $name => $conf){
        if($conf["Timing"] != 0) {
            $lines[] = $conf["Timing"]." root /usr/bin/systemctl start --no-block zfs-replicate@$name.service";
        }
    }
    $lines[] = "";
    $cmd = "sudo chown www-data ".ZFS_FILE_CRON_REPLICATE;
    exec($cmd);
    file_put_contents(ZFS_FILE_CRON_REPLICATE, implode(PHP_EOL, $lines));
    $cmd = "sudo chown root ".ZFS_FILE_CRON_REPLICATE;
    exec($cmd);
}
?>
