<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_snapshot_rm(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{snapshots}";
    }else
    if ( !is_array($request->params->snapshots) && !is_object($request->params->snapshots) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:snapshots";
    }else{
        $err = false;
        $errmsg = [];
        foreach ($request->params->snapshots as $snapshot) {
            $snap = "${snapshot[0]}/${snapshot[1]}@${snapshot[2]}";
            $cmd = sprintf(ZFS_CMD_SNAPSHOT_RM, escapeshellarg($snap));
            $content = [];
            exec($cmd, $content, $ret);
            if ($ret !== 0) {
                $err = true;
                $errmsg = array_merge($errmsg, [$snap], $content);
            }
        }
        if ($err){
            $respond->err = ERR_FAILED;
            $respond->errmsg = implode(PHP_EOL, $errmsg);
        }else{
            $respond->err = ERR_SUCCEED;
        }
    }
    return true;
}
?>
