<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_snapshot_send(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,zfilesys,name,sendto}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !validString($request->params->sendto) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:sendto";
    }else{
        $zpool = $request->params->zpool;
        $zfilesys = validString($request->params->zfilesys) ? $request->params->zfilesys : "";
        $name = validString($request->params->name) ? $request->params->name : date('Y-m-d_H:i:s');
        $sendto = $request->params->sendto;

        $zfs_path = $zpool.($zfilesys ? "/$zfilesys" : "");
        $zfs_snapname = "$zfs_path@$name";

        if (!is_dir(ZFS_DIR_RUN_SEND_CONF)) {
            exec("sudo mkdir -p ".ZFS_DIR_RUN_SEND_CONF."; sudo chown www-data:www-data ".ZFS_DIR_RUN_SEND_CONF);
        }
        if (!is_writable(ZFS_DIR_RUN_SEND_CONF)) {
            exec("sudo chown www-data:www-data ".ZFS_DIR_RUN_SEND_CONF);
        }

        $task_name = md5("$zfs_snapname-$sendto");
        $tmp_file = ZFS_DIR_RUN_SEND_CONF."/$task_name";

        $task_conf = [
            "name" => $task_name,
            "type" => "local",
            "sendto" => $sendto,
            "dataset" => $zfs_snapname,
            "zfs" => $zfs_path,
            "snapshot" => $name,
        ];
        file_put_contents($tmp_file, json_encode($task_conf));

        $send_cmd = sprintf(ZFS_CMD_SNAPSHOT_SEND, $task_name);
        exec($send_cmd);

        $respond->err = ERR_SUCCEED;
    }
    return true;
}
?>
