<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_snapshot_set(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,zfilesys,autosnap}";
    }else
    if ( !is_array($request->params->zfs) && !is_object($request->params->zfs))
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfs";
    }else
    if ( !isset($request->params->autosnap) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:autosnap";
    }else{
        if ($request->params->autosnap){
            $autosnap_param = check_autosnap($request->params);
            if ($autosnap_param){
                $autoSnapshotJson = [];
                if(file_exists(ZFS_FILE_AUTOSNAP)){
                    $autoSnapshotJson = json_decode(file_get_contents(ZFS_FILE_AUTOSNAP), true);
                }
                foreach ($request->params->zfs as $zfs) {
                    $zfs_path = "${zfs[0]}/${zfs[1]}";
                    $autoSnapshotJson[$zfs_path] = $autosnap_param;
                }
                file_put_contents(ZFS_FILE_AUTOSNAP, json_encode($autoSnapshotJson));
                $respond->err = ERR_SUCCEED;
            }
        }else{
            // Close auto snap
            if(file_exists(ZFS_FILE_AUTOSNAP)){
                $autoSnapshotJson = json_decode(file_get_contents(ZFS_FILE_AUTOSNAP), true);
                $changed = false;
                foreach ($request->params->zfs as $zfs) {
                    $zfs_path = "${zfs[0]}/${zfs[1]}";
                    if (isset($autoSnapshotJson[$zfs_path])){
                        unset($autoSnapshotJson[$zfs_path]);
                        $changed = true;
                    }
                }
                if ($changed) {
                    file_put_contents(ZFS_FILE_AUTOSNAP, json_encode($autoSnapshotJson));
                }
            }
            $respond->err = ERR_SUCCEED;
        }

    }
    return true;
}

function check_autosnap($params){
    global $respond;
    if ( !isset($params->frequent) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:frequent";
    }else
    if ( !validInteger($params->frequent_copies) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:frequent_copies";
    }else
    if ( !isset($params->hourly) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:hourly";
    }else
    if ( !validInteger($params->hourly_copies) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:hourly_copies";
    }else
    if ( !isset($params->daily) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:daily";
    }else
    if ( !validInteger($params->daily_copies) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:daily_copies";
    }else
    if ( !isset($params->weekly) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:weekly";
    }else
    if ( !validInteger($params->weekly_copies) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:weekly_copies";
    }else
    if ( !isset($params->monthly) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:monthly";
    }else
    if ( !validInteger($params->monthly_copies) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:monthly_copies";
    }else{
        $param = [
            'Minutely' => $params->frequent,
            'MinutelyCopies' => $params->frequent_copies,
            'Hourly' => $params->hourly,
            'HourlyCopies' => $params->hourly_copies,
            'Daily' => $params->daily,
            'DailyCopies' => $params->daily_copies,
            'Weekly' => $params->weekly,
            'WeeklyCopies' => $params->weekly_copies,
            'Monthly' => $params->monthly,
            'MonthlyCopies' => $params->monthly_copies,
        ];
        return $param;
    }
    return false;
}
?>
