<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_snapshot_umount(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,zfilesys,name}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !validString($request->params->zfilesys) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfilesys";
    }else
    if ( !validString($request->params->name) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:name";
    }else{
        $zpool = $request->params->zpool;
        $zfilesys = $request->params->zfilesys;
        $name = $request->params->name;

        $snap_path = "$zpool/$zfilesys@$name";

        $cmd = sprintf(ZFS_CMD_SNAPSHOT_UMOUNT, $snap_path);
        exec($cmd, $content, $ret);
        if ($ret == 0){
            $cmd = "sudo rmdir '/mnt/$snap_path'";
            exec($cmd);
            $respond->err = ERR_SUCCEED;
        }else{
            $respond->err = ERR_FAILED;
            $respond->code = $ret;
            $respond->errmsg = implode(PHP_EOL, $content);
        }
    }
    return true;
}
?>
