<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_zfilesys_create(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,zfilesys,quota,reservation,zpoolfree,zfilesys_type,compression,thin_provision,zfs_dedup,crypt,crypt_pwd}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !is_int($request->params->quota) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:quota";
    }else
    if ( !is_int($request->params->reservation) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:reservation";
    }else
    if ( !is_int($request->params->zpoolfree) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpoolfree";
    }else
    if ( !validString($request->params->zfilesys_type) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfilesys_type";
    }else
    if ( !validString($request->params->compression) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:compression";
    }else
    if ( !isset($request->params->thin_provision) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:thin_provision";
    }else
    if ( !isset($request->params->zfs_dedup) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfs_dedup";
    }else
    if ( !isset($request->params->crypt) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:crypt";
    }else{
        $zfs = \UNAS\Volume\Volume::CreateVolumeObject("zfs");
        $zpool = $request->params->zpool;
        $zfilesys = $request->params->zfilesys;
        $quota = $request->params->quota;
        $reservation = $request->params->reservation;
        $zpoolfree = $request->params->zpoolfree;
        $zfilesys_type = $request->params->zfilesys_type;
        $compression = $request->params->compression;
        $thin_provision = $request->params->thin_provision;
        $zfs_dedup = $request->params->zfs_dedup;
        $encrypt = $request->params->crypt;

        if ( $encrypt != "off" )
        {
            if (!validString($request->params->crypt_pwd)){
                $respond->err    = ERR_PARAMS;
                $respond->errmsg = "缺少参数或参数内容错误:crypt_pwd";
            }else{
                $encrypt_pwd = $request->params->crypt_pwd;
            }
        }else{
            $encrypt_pwd = "";
        }

        $volume_attrs = array(
            "name" => $zfilesys,
            "quota" => $quota,
            "reservation" => $reservation,
            "zpoolfree" => $zpoolfree,
            "type" => $zfilesys_type,
            "thin_provision" => $thin_provision,
            "dedup" => $zfs_dedup,
            "compress" => $compression,
            "encrypt" => $encrypt,
            "encrypt_pwd" => $encrypt_pwd,
        );

        $ret_zfilesyscreate = $zfs->CreateVolume($zpool,$volume_attrs);

        if($ret_zfilesyscreate){
            $eventDes = "##$@zfszfilesyscreate@$##In zpool##$@zfszfilesyscreate@$## $zpool ##$@zfszfilesyscreate@$##successfully created a##$@zfszfilesyscreate@$## ${quota}M ##$@zfszfilesyscreate@$##dataset##$@zfszfilesyscreate@$## $zfilesys";
            appLog("Information", $eventDes);
            $respond->err = ERR_SUCCEED;
        }else{
            $eventDes = "##$@zfszfilesyscreate@$##In zpool##$@zfszfilesyscreate@$## $zpool ##$@zfszfilesyscreate@$##failed to create a##$@zfszfilesyscreate@$## ${quota}M ##$@zfszfilesyscreate@$##dataset##$@zfszfilesyscreate@$## $zfilesys";
            appLog("Error", $eventDes);
            $respond->err = ERR_FAILED;
        }
    }
    return true;
}
?>
