<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_zfilesys_edit(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,zfilesys,zfilesyssize,zfilesys_type,compression,zfs_dedup}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !validString($request->params->zfilesys) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfilesys";
    }else
    if ( !validInteger($request->params->zfilesyssize) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfilesyssize";
    }else
    if ( !validString($request->params->zfilesys_type) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfilesys_type";
    }else
    if ( !validString($request->params->compression) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:compression";
    }else
    if ( !isset($request->params->zfs_dedup) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfs_dedup";
    }else{
        //$zfs = \UNAS\Volume\Volume::CreateVolumeObject("zfs");
        $zpool = $request->params->zpool;
        $zfilesys = $request->params->zfilesys;
        $zfilesyssize = $request->params->zfilesyssize;
        $zfilesys_type = $request->params->zfilesys_type;
        $compression = $request->params->compression;
        $zfs_dedup = $request->params->zfs_dedup;

        $set_item_list = [];

        $set_item_list[] = ($zfilesys_type == "volume" ? "volsize" : "quota")."=${zfilesyssize}MB";
        $set_item_list[] = "reservation=${zfilesyssize}MB";
        $set_item_list[] = "dedup=".($zfs_dedup ? "on" : "off");
        $set_item_list[] = "compression=".($compression ? $compression : "off");

        $cmd = "sudo zfs set ".implode(" ", $set_item_list)." $zpool/$zfilesys";
        exec($cmd, $content, $ret);

        if($ret == 0){
            $eventDes = "##$@zfszfilesysedit@$##zfs Volume##$@zfszfilesysedit@$## $zpool ##$@zfszfilesysedit@$##expands to##$@zfszfilesysedit@$## ${zfilesyssize} MB";
            appLog("Information", $eventDes);
            $respond->err = ERR_SUCCEED;
        }else{
            $eventDes = "##$@zfszfilesysedit@$##zfs Volume##$@zfszfilesysedit@$## $zpool ##$@zfszfilesysedit@$##edit failed##$@zfszfilesysedit@$##";
            appLog("Error", $eventDes);
            $respond->err = ERR_FAILED;
            $respond->errmsg = implode(PHP_EOL, $content);
        }
    }
    return true;
}
?>
