<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_zfilesys_info(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,zfilesys}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !validString($request->params->zfilesys) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfilesys";
    }else{
        $zfs = \UNAS\Volume\Volume::CreateVolumeObject("zfs");
        $zpool = $request->params->zpool;
        $zfilesys = $request->params->zfilesys;

        $info = [];

        $property_list = [
            "mounted",
            "mountpoint",
            "type",
            "dedup",
            "compression",
            "compressratio",
            "encryption",
            "avail",
            "reserv",
            "quota",
            "used",
        ];
        $cmd = "zfs list $zpool/$zfilesys -Hp -o ".implode(',', $property_list);
        $value_list = explode("\t", exec($cmd));
        for ($i = 0; $i < count($property_list); $i++){
            $info[$property_list[$i]] = $value_list[$i];
        }

        $cmd = "zfs list $zpool -Hp -o avail";
        $zpoolfree_size = (int)exec($cmd);

        $zfs_info = [
            "avail" => (int)$info["avail"]/1024,
            "size" => ($info["type"] == "volume" ? (int)$info["reserv"] : (int)$info["quota"])/1024 ,
            "used" => (int)$info["used"]/1024,
            "zpoolfree_size" => ($zpoolfree_size)/1024,
            "dedup" => $info["dedup"] == "on",
            "compression" => $info["compression"],
            "compressratio" => (float)$info["compressratio"],
            "encryption" => $info["encryption"],
            "type" => $info["type"],
            "mounted" => $info["mounted"] == "yes",
            "mountpoint" => $info["mountpoint"],
            "snap" => $zfs->GetSnapshot($zpool, $zfilesys),
        ];

        $respond->results = $zfs_info;
        $respond->err = ERR_SUCCEED;
    }
    return true;
}

/**
 * Get params from a config line.
 *
 *  Cautions: The params may contain quotation marks.
 *  Cautions: All letters after '#' will be regard as comment.
 * @param string $config_line   The config line.
 * @return array                [$0, $1, $2...]
 */
function GetParams(string $config_line){
    // Replace special chars
    $patterns = ['/\(/','/\)/'];
    $replacement = ['\(','\)'];
    $cmd = 'printf "%s\n" '.preg_replace($patterns, $replacement, $config_line);
    exec($cmd, $content, $ret);

    return $content;
}

?>
