<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_zfilesys_mount(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,zfilesys}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !validString($request->params->zfilesys) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zfilesys";
    }else{
        $zfs = \UNAS\Volume\Volume::CreateVolumeObject("zfs");
        $zpool = $request->params->zpool;
        $zfilesys = $request->params->zfilesys;
        $zfs_path = "$zpool/$zfilesys";

        if (validString($request->params->crypt_pwd)){
            $crypt_pwd = $request->params->crypt_pwd;
            if (!$zfs->LoadEncryptPass($crypt_pwd, $zfs_path)){
                // pass failure
                $respond->err = ERR_PASSWORD; // 9953
                return true;
            }
        }
        $res = $zfs->MountVolume($zfs_path);

        if ($res){
            $eventDes = "##$@zfsunmount@$##Logical Volume##$@zfsunmount@$## $zfs_path ##$@zfsunmount@$##unmount success##$@zfsunmount@$##";
            appLog("Information", $eventDes);
            $respond->err = ERR_SUCCEED;
        }else{
            $eventDes = "##$@zfsunmount@$##Logical Volume##$@zfsunmount@$## $zfs_path ##$@zfsunmount@$##unmount failure##$@zfsunmount@$##";
            appLog("Error", $eventDes);
            $respond->err = ERR_FAILED;
        }
    }
    return true;
}
?>
