<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_zpool_edit(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool,pvs,raidLevel,spares,logs,cache,ashift}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else
    if ( !is_array($request->params->pvs) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:pvs";
    }else
    if ( !validString($request->params->raidLevel) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:raidLevel";
    }else
    if ( !is_array($request->params->spares) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:spares";
    }else
    if ( !is_array($request->params->logs) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:logs";
    }else
    if ( !is_array($request->params->cache) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:cache";
    }else
    if ( !is_array($request->params->extend_pv) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:extend_pv";
    }else
    if ( !is_int($request->params->log_mirror) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:log_mirror";
    }else{

        $zfs = \UNAS\Volume\Volume::CreateVolumeObject("zfs");
        $zpool = $request->params->zpool;
        $pvs = $request->params->pvs;
        $raidLevel = $request->params->raidLevel; //0-strip, 1-mirror, 5-raidz1, 6-raidz2, 10, raidz3
        $spares = $request->params->spares;
        $logs = $request->params->logs;
        $cache = $request->params->cache;
        $extend_pv = $request->params->extend_pv;
        $log_mirror = $request->params->log_mirror;
        $dedups = asArray($request->params->dedup);
        $specials = asArray($request->params->special);

        $errorPool = 0; //
        $errorCache=0; //no error
        $errorLog=0;
        $errorSpare=0;
        $errorDedup=0;
        $errorSpecial=0;

        if ($zpool){
            //zpool labelclear , clean all disks first
            foreach($extend_pv as $d){
                exec("/usr/bin/sudo zpool labelclear -f " . $d);  //clear all label of the devices (all selected disks)
            }
            //did two clean up?
            $pvdevices = array();
            foreach($extend_pv as $dev){ //clear all devices selected.
                if(\UNAS\Disk\InitializeDisk($dev)){
                    $pvdevices[] = dev_id($dev);
                }
            }

            //add vdev to pool.
            if($raidLevel == "stripe"){
                $raidLevel = ""; //stripe does not show in the commandline
            }
            if(!empty($pvs)){

                $dev_list=[];
                foreach($pvs as $dev){
                    $dev_list[] = dev_id($dev);
                }

                $zpoolType = zpoolMemberType($request->params->zpool, $device);
                if ( $zpoolType == "raidz1" || $zpoolType == "raidz2" || $zpoolType == "raidz3" )
                {
                    exec("sudo zpool attach -f $zpool $device " . implode(' ', $dev_list), $output, $err);
                    if ( !$err )
                    {
                        $eventDes = "##$@zfssuc@$##Successfully added vdev Device to pool##$@zfssuc@$##: $zpool";
                        appLog("Information", $eventDes);
                    }else
                    {
                        $eventDes = "##$@zfsfail@$##Failed to add vdev Device to pool##$@zfsfail@$##: $zpool";
                        appLog("Error", $eventDes);
                        $errorPool=1; //add cache failed
                    }
                }else
                {
                    $cmd = sprintf(ZFS_CMD_ZPOOL_ADD, $zpool, $raidLevel, implode(' ', $dev_list));
                    exec($cmd, $output, $r);
                    if($r == 0){
                        $eventDes = "##$@zfssuc@$##Successfully added vdev Device to pool##$@zfssuc@$##: $zpool";
                        appLog("Information", $eventDes);
                    }else{
                        $eventDes = "##$@zfsfail@$##Failed to add vdev Device to pool##$@zfsfail@$##: $zpool";
                        appLog("Error", $eventDes);
                        $errorPool=1; //add cache failed
                    }
                }
            }

            //cache
            if(!empty($cache)){
                $dev_list=[];
                foreach($cache as $dev){
                    $dev_list[] = dev_id($dev);
                }
                $cmd = sprintf(ZFS_CMD_ZPOOL_ADD, $zpool, "cache", implode(' ', $dev_list));
                exec($cmd, $output, $r);
                if($r == 0){
                    $eventDes = "##$@zfssuc@$##Successfully added cache Device to pool##$@zfssuc@$##: $zpool";
                    appLog("Information", $eventDes);
                }else{
                    $eventDes = "##$@zfsfail@$##Failed to add cache Device to pool##$@zfsfail@$##: $zpool";
                    appLog("Error", $eventDes);
                    $errorCache=1; //add cache failed
                }
            }

            //spares
            if(!empty($spares)){
                $dev_list=[];
                foreach($spares as $dev){
                    $dev_list[] = dev_id($dev);
                }
                $cmd = sprintf(ZFS_CMD_ZPOOL_ADD, $zpool, "spare", implode(' ', $dev_list));
                exec($cmd, $output, $r);
                if($r == 0){
                    $eventDes = "##$@zfssuc@$##Successfully added spare Device to pool##$@zfssuc@$##: $zpool";
                    appLog("Information", $eventDes);
                }else{
                    $eventDes = "##$@zfsfail@$##Failed to add spare Device to pool##$@zfsfail@$##: $zpool";
                    appLog("Error", $eventDes);
                    $errorSpare = 1; //add spares Failed
                }
            }

            //logs
            if(!empty($logs)){
                $type = "log";
                if ($log_mirror == 1){//mirror for logs
                    $type += " mirror";
                }
                $dev_list=[];
                foreach($logs as $dev){
                    $dev_list[] = dev_id($dev);
                }
                $cmd = sprintf(ZFS_CMD_ZPOOL_ADD, $zpool, $type, implode(' ', $dev_list));
                exec($cmd, $output, $r);
                if($r == 0){
                    $eventDes = "##$@zfssuc@$##Successfully added log Device to pool##$@zfssuc@$##: $zpool";
                    appLog("Information", $eventDes);
                }else{
                    $eventDes = "##$@zfsfail@$##Failed to add log Device to pool##$@zfsfail@$##: $zpool";
                    appLog("Error", $eventDes);
                    $errorLog=1;
                }
            }
            //dedup
            if(!empty($dedups)){
                $type = "dedup";
                if ($log_mirror == 1){//mirror for dedup
                    $type += " mirror";
                }
                $dev_list=[];
                foreach($dedups as $dev){
                    $dev_list[] = dev_id($dev);
                }
                $cmd = sprintf(ZFS_CMD_ZPOOL_ADD, $zpool, $type, implode(' ', $dev_list));
                exec($cmd, $output, $r);
                if($r == 0){
                    $eventDes = "##$@zfssuc@$##Successfully added dedup Device to pool##$@zfssuc@$##: $zpool";
                    appLog("Information", $eventDes);
                }else{
                    $eventDes = "##$@zfsfail@$##Failed to add dedup Device to pool##$@zfsfail@$##: $zpool";
                    appLog("Error", $eventDes);
                    $errorDedup=1;
                }
            }
            //specials
            if(!empty($specials)){
                $type = "special";
                if ($log_mirror == 1){//mirror for special
                    $type += " mirror";
                }
                $dev_list=[];
                foreach($specials as $dev){
                    $dev_list[] = dev_id($dev);
                }
                $cmd = sprintf(ZFS_CMD_ZPOOL_ADD, $zpool, $type, implode(' ', $dev_list));
                exec($cmd, $output, $r);
                if($r == 0){
                    $eventDes = "##$@zfssuc@$##Successfully added special Device to pool##$@zfssuc@$##: $zpool";
                    appLog("Information", $eventDes);
                }else{
                    $eventDes = "##$@zfsfail@$##Failed to add special Device to pool##$@zfsfail@$##: $zpool";
                    appLog("Error", $eventDes);
                    $errorSpecial=1;
                }
            }
        }
        $respond->err = ERR_SUCCEED;
        $respond->results = [
            "errorPool"  => $errorPool,
            "errorLog"   => $errorLog,
            "errorCache" => $errorCache,
            "errorSpare" => $errorSpare,
            "errorDedup" => $errorDedup,
            "errorSpecial" => $errorSpecial,
        ];

        $respond->err = ERR_SUCCEED;
    }
    return true;
}

$dev_id_list = [];
function dev_id(string $name){
    global $dev_id_list;
    if (empty($dev_id_list)){
        foreach (glob("/dev/disk/by-id/*") as $id_raw){
            if (is_link($id_raw)){
                $dev_id_list[basename(realpath($id_raw))] = basename($id_raw);
            }
        }
    }
    $devname = basename($name);
    if (isset($dev_id_list[$devname])){
        return $dev_id_list[$devname];
    }else{
        return $name;
    }
}

function zpoolMemberType(string $name, &$device)
{
    $ret = '';
    exec("zpool status -j --json-flat-vdevs $name", $output, $err);
    if ( !$err )
    {
        $json = json_decode($output[0]);
        $pools = (array)$json->pools;
        $poolArray = (array)$pools[$name];
        $vdevsArray = (array)$poolArray['vdevs'];
        if ( ! empty($vdevsArray) )
        {
            $ret = 'stripe';
            foreach( $vdevsArray as $devid=>$obj )
            {
                $classify = substr($devid, 0, 7);
                if ( $classify == "draid1:"
                  || $classify == "draid2:"
                  || $classify == "draid3:" )
                {
                    $device = $obj->name;
                    $ret = substr($obj->name, 0, 6);
                }else
                if ( $obj->vdev_type == "mirror" )
                {
                    $device = $obj->name;
                    $ret = $obj->vdev_type;
                }else
                if ( $obj->vdev_type == "raidz" )
                {
                    $device = $obj->name;
                    $ret = substr($obj->name, 0, 6);
                }
            }
        }
    }
    return $ret;
}


?>
