<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_zpool_export(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else{
        $zpool = $request->params->zpool;

        $cmd = sprintf(ZFS_CMD_ZPOOL_EXPORT, $zpool);
        exec($cmd, $out, $ret);
        if($ret == 0){
            $eventDes = "##$@zfszfilesysdelete@$##Successfully exported zpool:##$@zfszfilesysdelete@$## $zpool";
            appLog("Information", $eventDes);
            $respond->err = ERR_SUCCEED;
        }else{
            $eventDes = "##$@zfszfilesysdelete@$##Failed export zpool:##$@zfszfilesysdelete@$## $zpool";
            appLog("Error", $eventDes);
            $respond->err = ERR_FAILED;
            $respond->errmsg = implode(PHP_EOL, $out);
        }
    }
    return true;
}
?>
