<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_zpool_remove(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    if ( ! isset($request->params) || !(gettype($request->params) == "array" || gettype($request->params) == "object") )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数:params{zpool}";
    }else
    if ( !validString($request->params->zpool) )
    {
        $respond->err    = ERR_PARAMS;
        $respond->errmsg = "缺少参数或参数内容错误:zpool";
    }else{
        $zfs = \UNAS\Volume\Volume::CreateVolumeObject("zfs");
        $zpool = $request->params->zpool;

        if($zpool && $zfs->VolumeGroupExists($zpool)){
            \UNAS\Folder\DeleteSharedFolderConfigureInVG($zpool); //remove all shared folders configurations in smb,ftp,webdav,nfs, ....
            $ret_delzpool = $zfs->DeleteVolumeGroup($zpool);
            if($ret_delzpool){
                $eventDes = '##$@zfssuc@$##Successfully deleted Volume Group##$@zfssuc@$## '.$zpool;
                appLog("Information", $eventDes);
                $respond->err = ERR_SUCCEED;
            }else{
                $eventDes = '##$@zfsfail@$##Failed to delete Volume Group##$@zfsfail@$## '.$zpool;
                appLog("Error", $eventDes);
                $respond->err = ERR_FAILED;
            }
        }
    }
    return true;
}
?>
