<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_zpools_info(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    $respond->results = zpools();
    $respond->err = ERR_SUCCEED;
    return true;
}
///---INTERFACE-METHODS---END---///

function zpools(){
    $zfs = \UNAS\Volume\Volume::CreateVolumeObject("zfs");
    $zpools = $zfs->GetAllVolumeGroups();
    //$zfilesyss = $zfs->GetAllVolumes();
    $totalzpool = count($zpools);
    $zpoolpvarr = array();
    $df = \UNAS\Utility\GetDfInfo(); //get all  all df information (df command)

    for($i=0; $i<$totalzpool; $i++){
        $zpools[$i]['zfilesyss']=array();
        $zpools[$i]['pvs'] =  array();
        $zfilesyss = $zfs->GetVolumesInVolumeGroup($zpools[$i]['name']);
        $zfilesys_list = array(); //list of ZFILESYS names;
        $snapshots = [];

        //get all zfilesyss for the zpool.
        foreach($zfilesyss as $zfilesys){
            $zfilesys_list[]=$zfilesys['name']; //
            $zfilesys['dfinfo'] = array();
            $volumePath = $zfilesys['zpool']."/".$zfilesys['name']; //should use $zfs->GetVolumePath()
            //$mountPath = $zfs->GetVolumeMountPoint($volumePath);
            $mountPath = $zfilesys['mountpoint'];

            for($d=0;$d<count($df);$d++){
                if($df[$d][5] == $mountPath){
                    $fs_size = $df[$d][1];
                    $fs_free = $df[$d][3];
                    if(preg_match("/^([0-9\.]*)(\w+)/",$fs_free,$fsfree))
                        $fs_free = $fsfree[1]." ".$fsfree[2]."B";
                    if(preg_match("/^([0-9\.]*)(\w+)/",$fs_size,$fssize))
                        $fs_size = $fssize[1]." ".$fssize[2]."B";
                    $used_percent = $df[$d][4];
                    $zfilesys['dfinfo']=array(
                        "avail" => $fs_free,
                        "size" => $fs_size,
                        "use" => $used_percent
                    );
                    break;
                }
            }
            $zfilesys['snap'] = $zfs->GetSnapshot($zfilesys['zpool'],$zfilesys['name']);
            $snapshots = array_merge($snapshots, $zfilesys['snap']);
            $zfilesys['snapshot'] = false;

            $zpools[$i]['zfilesyss'][] = $zfilesys;
        }
        //get all pvs for the zpool.

        //get all mounted snapshots of the pool (zpool).
        foreach($snapshots as $snapshot)
        {
            if ($snapshot["mounted"]){
                $snapshot["snapshot"] = true;
                $zpools[$i]['zfilesyss'][] = $snapshot; //push to
            }
        }
    }
    return $zpools;
}
?>
