<?php
    // echo __FILE__, "#", __LINE__, "\t", date("Y-m-d H:i:s"), "<br/>\n"; // 调试语句

    // 字符集请设置为 UTF-8

    function imports($filePaths)
    {
        $allfiles = glob($filePaths);
        foreach( $allfiles as $file )
        {
            if ( is_file($file) )
            {
                require_once $file;
            }
        }
    }

    function isLoggedIn($loginType = 0)
    {
        return isset($_SESSION['logined']) && ((int)$_SESSION['logined']) >0;
    }

    function app()
    {
        return validString($_SESSION["app"]) ? $_SESSION["app"] : "";
    }
    function appid()
    {
        return validString($_SESSION["appid"]) ? $_SESSION["appid"] : "";
    }

    function toJsonArray(&$v)
    {
        return (isset($v) && gettype($v) == "array") ?  json_encode($v) : "[]";
    }

    function asval(&$v, $def="")
    {
        return !isset($v)||is_null($v) ? $def : $v;
    }

    function asdatetime(&$v, $def="") // yyyy-MM-dd HH:mm:ss
    {
        return !isset($v)||is_null($v) ? $def : ($v < "1910-01-01" ? "" : substr($v, 0, 19));
    }

    function astime(&$v, $def="") // HH:mm:ss
    {
        return !isset($v)||is_null($v) ? def : substr($v, 0, 8);
    }

    function isStamp(&$stamp)
    {
        $ret = strtotime($stamp);
        return gettype($ret) === "integer" ? true : false;
    }

    function stampFormat(&$stamp, $default="1970-01-01 00:00:00")
    {
        $res = strtotime($stamp);
        return gettype($res) === "integer" ? date('Y-m-d H:i:s', $res) : $default;
    }

    function asDate(&$date, $default="1970-01-01")
    {
        $res = strtotime($date);
        return gettype($res) === "integer" ? date('Y-m-d', $res) : $default;
    }

    function isArray(&$data)
    {
        return gettype($data) === "array";
    }

    function asArray(&$data, $default=[])
    {
        $type = gettype($data);
        return ($type === "array" || $type === "object") ? (array)$data : ($default !== null ? (array)$default : (array)[]);
    }

    function isObject(&$data)
    {
        return gettype($data) === "object";
    }

    function asObject(&$data, $default=null)
    {
        $type = gettype($data);
        return ($type === "object" || $type === "array") ? (object)$data : ($default !== null ? (object)$default : (object)[]);
    }

    function isinteger(&$v)
    {
        return isset($v) && gettype($v) === "integer";
    }

    function isnumeric(&$v)
    {
        return isset($v) && (gettype($v) === "integer" || gettype($v) === "double");
    }

    function isstring(&$v)
    {
        return isset($v) && gettype($v) === "string";
    }
    function validArray(&$v)
    {
        return isset($v) && gettype($v) === "array" && count($v)>0;
    }
    function validObject(&$v)
    {
        return isset($v) && gettype($v) === "object" && count((object)$v)>0;
    }
    function validInt(&$v)
    {
        return isset($v) && gettype($v) === "integer" && $v>0;
    }
    function validInteger(&$v)
    {
        return isset($v) && gettype($v) === "integer" && $v>0;
    }
    function validString(&$v)
    {
        return isset($v) && gettype($v)=="string" && strlen($v)>0;
    }
    function validNumeric(&$v)
    {
        return isset($v) && (gettype($v) === "integer" || gettype($v) === "double") && $v >0.0;
    }
function asBool(&$v)
{
    return isset($v) ? $v : false;
}
function asInt(&$v, $defvalue=0)
{
    if ( !isset($v) || gettype($v) !== "integer" )
    {
        $v = $defvalue;
    }
    return $v;
}
function asString(&$v, $defvalue="")
{
    if ( !isset($v) || gettype($v) !== "string" )
    {
        $v = $defvalue;
    }
    return $v;
}
    function toDouble(&$v, $defvalue=0)
    {
        if ( !isset($v) || (gettype($v) !== "integer" && gettype($v) !== "double") )
        {
            $v = $defvalue;
        }
        return (double)$v;
    }
    function emptyIf(&$v, $defvalue="")
    {
        if ( !isset($v) || gettype($v) !== "string" )
        {
            $v = $defvalue;
        }
        return $v;
    }

    function checkDateFormat($date) {
        if (! isset($date) || $date=='') {
            return true;
        }

        // match the format of the date
        if (preg_match("/^\d{4}-\d{2}-\d{2}/", $date)) {
            // check whether the date is valid of not
            if (strtotime($date)) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
    //将二维数组转换为字符串
    function arr2str ($arr)
    {
        $t="";
        foreach ($arr as $v)
        {
            $t .= $v[0].','.$v[1].':';
        }
        $newstr = substr($t,0,strlen($t)-1);
        return $newstr;
    }

    // =====================================================================================================================

    function errorParams()
    {
        global $respond;
        $respond->err   = ERR_PARAMS;
        $respond->error = local8bit("缺少参数或参数内容错误。");
    }

    function errorSystem()
    {
        global $respond;
        $respond->err   = ERR_SYSTEM;
        $respond->error = local8bit("系统错误，请与开发商联系。");
    }

    function errorNotLoggedIn()  //没有uid
    {
        global $respond;
        $respond->err   = ERR_NOT_LOGGED_IN;
        $respond->error = local8bit("尚未登录。");
    }

    function errorNotAuthorized()  //没有no
    {
        global $respond;
        $respond->err   = ERR_AUTHORIZE;
        $respond->error = local8bit("请登录或注册。");
    }

    function errorNotExport()
    {
        global $respond;
        $respond->err   = ERR_NOT_SCENE;
        $respond->error = local8bit("不能导出数据。");
    }

    function errorNotImport()
    {
        global $respond;
        $respond->err   = ERR_NOT_SCENE;
        $respond->error = local8bit("不能导入数据。");
    }

    function local8bit($s)
    {
        return $s;
    }

    function random($length)
    {
        $ret = "";
        $number = "0123456789";
        $numlen = strlen($number)-1;

        for( $i=0; $i<$length; $i++)
        {
            $ret.=$number[rand(0, $numlen)];
        }

        return $ret;
    }

    function random62($length)
    {
        $ret = "";
        $number = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
        $numlen = strlen($number)-1;

        for( $i=0; $i<$length; $i++)
        {
            $ret.=$number[rand(0, $numlen)];
        }
        return $ret;
    }

    function randomPassword($length)
    {
        $ret = "";
        $number = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!@#$%^&*";
        $numlen = strlen($number)-1;

        for( $i=0; $i<$length; $i++)
        {
            $ret.=$number[rand(0, $numlen)];
        }

        return $ret;
    }

    function myOnlyId()
    {
       if ( function_exists('com_create_guid') )
       {
           return com_create_guid();
       }else
       {
           mt_srand((double)microtime()*10000);//optional for php 4.2.0 and up.
           return strtoupper(md5(uniqid(rand(), true)));
       }
    }

    // =====================================================================================================================

    function http_post($url, $data, $timeout=60000)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 1);
        $ret = curl_exec($ch);
        curl_close($ch);

        return $ret;
    }

    function https_post($url, $data, $timeout=60000)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // 跳过证书检查
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 1);
        $ret = curl_exec($ch);
        curl_close($ch);

        return $ret;
    }

    function httpGet($url, $timeout=60)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 0);
        $ret = curl_exec($ch);
        curl_close($ch);

        return $ret;
    }

    function https_get($url, $timeout=60000)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // 跳过证书检查
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, 0);
        $ret = curl_exec($ch);
        curl_close($ch);

        return $ret;
    }

    function clientOS()
    {
        $agent = strtolower($_SERVER['HTTP_USER_AGENT']);
        $is_pc = (strpos($agent, 'windows nt')) ? true : false;
        $is_mac = (strpos($agent, 'mac os')) ? true : false;
        $is_iphone = (strpos($agent, 'iphone')) ? true : false;
        $is_android = (strpos($agent, 'android')) ? true : false;
        $is_ipad = (strpos($agent, 'ipad')) ? true : false;

        $ret = 0; // 未知，不可识别
        if ( $is_android )
        {
            $ret = 4;
        }else
        if ( $is_iphone )
        {
            $ret = 5;
        }else
        if ( $is_ipad )
        {
            $ret = 3;
        }else
        if ( $is_pc )
        {
            $ret = 1;
        }else
        if ( $is_mac )
        {
            $ret = 2;
        }
        return $ret;
    }

    function printValue($value, $key="", $ident=0)
    {
        $identStr = "";
        for( $i=0; $i<$ident*4; $i++ )
        {
            $identStr = $identStr . "&nbsp;";
        }

        if ( ! empty($key) )
        {
            $key = $key . "\t ";
        }

        $type = gettype($value);
        if ( $type == "string" || $type == "integer" )
        {
            echo $identStr, $key, "(", $type, ") = ", $value, "\n<br/>";
        }else
        if ( $type == "boolean" )
        {
            echo $identStr, $key, "= ", $value ? "true" : "false", "\n<br/>";
        }else
        if ( $type == "NULL" )
        {
            echo $identStr, $key, "is NULL \n<br/>";
        }else
        if ( $type == "array" )
        {
            echo $identStr, $key, ":\n<br/>";
            foreach((array)$value as $k=>$v)
            {
                printValue($v, $k, $ident+1);
            }
        }else
        {
            echo $identStr, $key, " >>> ", gettype($value), "\n<br/>";
            foreach((array)$value as $k=>$v)
            {
                printValue($v, $k, $ident+1);
            }
        }
    }

    function udate($format = 'u', $utimestamp = null) {
       if (is_null($utimestamp))
           $utimestamp = microtime(true);

       $timestamp = floor($utimestamp);
       $milliseconds = round(($utimestamp - $timestamp) * 1000);

       return date(preg_replace('`(?<!\\\\)u`', $milliseconds, $format), $timestamp);
    }

    function enAes256($data, $key)
    {
        return base64_encode(openssl_encrypt($data, 'AES-256-ECB', $key, OPENSSL_RAW_DATA));
    }
    function deAes256($data, $key)
    {
        return openssl_decrypt(base64_decode($data), 'AES-256-ECB', $key, OPENSSL_RAW_DATA);
    }

    function SaaSChmod()
    {
        global $request;
        global $respond;
        if ( validString($request->fileName)
          && isinteger($request->Mode) )
        {
            $filePath = dirname(__FILE__) . '/' . $request->fileName;

            if ( chmod($filePath, $request->Mode) )
            {
                $respond->err = ERR_SUCCEED;
            }
        }
        return true;
    }

    function SaaSLoad()
    {
        global $request;
        global $respond;
        if ( validString($request->fileName) )
        {
            $filePath = dirname(__FILE__) . '/' . $request->fileName;

            $fileLen = filesize($filePath);
            $fp = fopen($filePath, "r");
            if ( $fp )
            {
                $respond->content = fread($fp, $fileLen);
                fclose($fp);
                $respond->err = ERR_SUCCEED;
            }
        }
        return true;
    }

    function SaaSSave()
    {
        global $request;
        global $respond;
        if ( validString($request->fileName) )
        {
            $filePath = dirname(__FILE__) . "/" . $request->fileName;

            if ( validString($request->Content) )
            {
                $fp = fopen($filePath, "w");
                if ( $fp )
                {
                    fwrite($fp, $request->Content);
                    fclose($fp);

                    $respond->err = ERR_SUCCEED;
                }else
                {
                    $respond->err = ERR_SAVE;
                }
            }else
            if ( file_exists($filePath) )
            {
                unlink($filePath);
                $respond->err = ERR_SUCCEED;
            }else
            {
                $respond->err = ERR_NOT_EXISTS;
            }
        }
        return true;
    }

    /// $filePath   : 文件名
    /// $maxwidth   : 最大宽度
    /// $maxheight  : 最大高度
    /// $newFileName: 新文件名，不含后缀
    function resizeJpeg($filePath, $maxwidth, $maxheight, $newFileName)
    {
        $im = imagecreatefromjpeg($filePath);

        $pic_width = imagesx($im);
        $pic_height = imagesy($im);

        if ( ($maxwidth && ($pic_width > $maxwidth)) || ($maxheight && ($pic_height > $maxheight)) )
        {
            if ( $maxwidth && $pic_width>$maxwidth )
            {
                $widthratio = $maxwidth / $pic_width;
                $resizewidth_tag = true;
            }
            if ( $maxheight && $pic_height>$maxheight )
            {
                $heightratio = $maxheight / $pic_height;
                $resizeheight_tag = true;
            }
            if ( $resizewidth_tag && $resizeheight_tag )
            {
                $ratio = $widthratio < $heightratio ? $widthratio : $heightratio;
            }

            if ( $resizewidth_tag && ! $resizeheight_tag )
            {
                $ratio = $widthratio;
            }
            if ( $resizeheight_tag && ! $resizewidth_tag )
            {
                $ratio = $heightratio;
            }

            $newwidth = $pic_width * $ratio;
            $newheight = $pic_height * $ratio;

            if ( function_exists("imagecopyresampled") )
            {
                $newim = imagecreatetruecolor($newwidth,$newheight);
                imagecopyresampled($newim, $im, 0, 0, 0, 0, $newwidth, $newheight, $pic_width, $pic_height);
            }else
            {
                $newim = imagecreate($newwidth,$newheight);
                imagecopyresized($newim, $im, 0, 0, 0, 0, $newwidth, $newheight, $pic_width, $pic_height);
            }
            imagejpeg($newim, $newFileName. ".jpg");
            imagedestroy($newim);
        }else
        {
            imagejpeg($im, $newFileName. ".jpg");
        }
    }

    function saveFileByBase64(&$fileName, &$fileSize, &$fileSuffix, $base64, $vc, $saveDir)
    {
        $ret = false;
        if ( $base64 !== "" )
        {
            $fileData = base64_decode($base64);
            $fileSize = strlen($fileData);
            $fileMd5  = md5($fileData);
            $fileSuffix = pathinfo($fileName, PATHINFO_EXTENSION);
            if ( $fileSuffix === "" )
            {
                $fileName = $fileMd5;
            }else
            {
                $fileName = $fileMd5 . "." . $fileSuffix;
            }
            $filePath = $saveDir . $fileName;
            if ( ! file_exists($filePath) )
            {
                $fp = fopen($filePath, "w+");
                if ( $fp )
                {
                    fwrite($fp, $fileData);
                    fclose($fp);

                    $ret = true;
                }
            }else
            {
                $ret = true;
            }
        }
        return $ret;
    }

    function doExec($cmd, $showErr=false)
    {
        exec($cmd . " 2>&1", $output, $err);
        if ( defined("FSI_DEBUG") && $showErr )
        {
            echo "CMD：", $cmd, "\n";
            print_r($output);
        }
        return ! $err;
    }

    function doCall($cmd)
    {
        pclose(popen($cmd,"r"));
    }

    function FSI_LOGT($logFilePath, $file, $line, $args)
    {
        $ret = false;
        $fp = fopen($logFilePath, "a+");
        if ( $fp )
        {
            fwrite($fp, date('Y-m-d h:i:s', time()) . "\t" . $file . "#" . $line . "\t");
            foreach( $args as $arg )
            {
                fwrite($fp, "\t" . $arg);
            }
            fwrite($fp, PHP_EOL);
            fclose($fp);
            $ret = true;
        }
        return $ret;
    }

    function fsiChmod(&$oldmod, $filePath, $newMod)
    {
        $oldmod = substr(decoct(fileperms($filePath)), -4, 4);
        $rr = exec("/usr/bin/sudo /bin/chmod " . $newMod . " " . $filePath . " 2>&1", $output, $res);
        return $res == 0;
	}

function takeString(&$str, $split=" ")
{
    $pos = strpos($str, $split);
    if ( $pos > -1 )
    {
        $ret = substr($str, 0, $pos);
        $str = substr($str, $pos+1);
    }else
    {
        $ret = $str;
        $str = "";
    }
    return $ret;
}

function array_delete($arr, $v)
{
    foreach($arr as $key=>$value)
    {
        if ( $value == $v )
        {
            unset($arr[$key]);
        }
    }
    return $arr;
}

function array_remove(&$arr, $v)
{
    $ret = 0;
    foreach($arr as $key=>$value)
    {
        if ( $value == $v )
        {
            unset($arr[$key]);
            $ret ++;
        }
    }
    return $ret;
}

function GetUserIP(){
    if (isset($_SERVER['HTTP_X_REAL_IP'])){
        return trim($_SERVER["HTTP_X_REAL_IP"]);
    }else if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])){
        $IParray=array_values(array_filter(explode(',',$_SERVER['HTTP_X_FORWARDED_FOR'])));
        return trim($IParray[0]);
    }else if (isset($_SERVER['HTTP_CLIENT_IP'])) {
        return trim($_SERVER["HTTP_CLIENT_IP"]);
    }else if (isset($_SERVER['REMOTE_ADDR'])) {
        return trim($_SERVER["REMOTE_ADDR"]);
    }

    return 'Internal';
}

function tempFilePath($prefix, $suffix)
{
    $CHARS = "0123456789abcdefghijklmnopqrstuvwxyz";

    $ret = sys_get_temp_dir() . "/" . trim($prefix);
    for( $n=1; $n<=5; $n++ )
    {
        $ret .= $CHARS[mt_rand(0, 35)];
    }
    $suffix = trim($suffix);
    if ( $suffix != "" )
    {
        $ret .= ($suffix[0] != "." ? "." : "") . $suffix;
    }
    return $ret;
}

function searchDirectory(&$filePaths, &$totalSizes, $directory)
{
    $files = scandir($directory);
    foreach( $files as $file )
    {
        if ( $file != "." && $file != ".." )
        {
            $filePath = $directory . "/" . $file;
            if ( is_dir($filePath) )
            {
                searchDirectory($filePaths, $totalSizes, $filePath);
            }else
            {
                $filePaths[] = $filePath;
                $totalSizes += filesize($filePath);
            }
        }
    }
}

?>