<?php
    // 字符集请设置为 UTF-8

    require_once("/unas/api/php/UNASlog.php");
    require_once("/unas/api/php/volume.php");
    require_once("/unas/api/php/folder.php");
    require_once("/unas/api/php/snapshot.php");
    require_once("/unas/api/php/utility.php");

    require_once(__DIR__."/utils/folder.php");

    define("APPID", "ZFS");

    define("ENABLED",  1);
    define("DISABLED", 0);

    define("ZFS_FILE_CRON_SCRUB", "/unas/etc/zfs/cron/scrub");
    define("ZFS_FILE_CRON_REPLICATE", "/unas/etc/zfs/cron/snap-replicate");
    define("ZFS_FILE_AUTOSNAP", "/unas/etc/zfs/autosnapshot.json");
    define("ZFS_FILE_REPLICATION", "/unas/etc/zfs/replicationtasks.json");
    define("ZFS_FILE_SEND_TMP", "/tmp/zfs-send-%s");
    define("ZFS_FILE_RECEIVE_TMP", "/tmp/zfs-receive-%s");

    define("ZFS_CMD_ZPOOL_SIZE","zpool get -Hp size %s | awk '{print $3}'");
    define("ZFS_CMD_ZFS_AVAIL_SIZE","zfs list -Hp -o avail %s");
    define("ZFS_CMD_ZPOOL_HEALTH","zpool status -x %s");
    define("ZFS_CMD_ZPOOL_ADD","sudo zpool add -f %s %s %s");
    define("ZFS_CMD_ZPOOL_IMPORT_LIST","zpool import | grep pool: | awk '{print $2}'");
    define("ZFS_CMD_ZPOOL_IMPORT","sudo zpool import -f %s");
    define("ZFS_CMD_ZPOOL_EXPORT","sudo zpool export -f %s");
    define("ZFS_CMD_SNAPSHOT_ZPOOL_CREATE","sudo zfs snapshot %s@%s 2>&1");
    define("ZFS_CMD_SNAPSHOT_CREATE","sudo zfs snapshot %s/%s@%s 2>&1");
    define("ZFS_CMD_SNAPSHOT_GET","sudo zfs list -Ht snapshot %s/%s");
    define("ZFS_CMD_SNAPSHOT_MOUNT","sudo mount -t zfs '%s' '/mnt/%s'");
    define("ZFS_CMD_SNAPSHOT_UMOUNT","sudo umount '/mnt/%s'");
    define("ZFS_CMD_SNAPSHOT_CLONE","sudo zfs clone '%s' '%s'");
    define("ZFS_CMD_SNAPSHOT_ROLLBACK","sudo zfs rollback -r '%s'");
    define("ZFS_CMD_SNAPSHOT_RM","sudo zfs destroy %s");
    define("ZFS_CMD_SNAPSHOT_SEND","sudo systemctl start zfs-send@%s.service");
    define("ZFS_CMD_SNAPSHOT_SEND_STATUS","sudo systemctl status zfs-send@%s.service");
    define("ZFS_CMD_SNAPSHOT_SEND_STOP","sudo systemctl stop zfs-send@%s.service");
    define("ZFS_CMD_SNAPSHOT_RECEIVE","sudo systemctl start zfs-receive@%s.service");
    define("ZFS_CMD_SNAPSHOT_RECEIVE_STATUS","sudo systemctl status zfs-receive@%s.service");
    define("ZFS_CMD_SNAPSHOT_RECEIVE_STOP","sudo systemctl stop zfs-receive@%s.service");

    // cron file must be owned by root
    // Add an additional space' ' in the end of line to help diff conf lines.
    define("ZFS_CMD_SCRUB_SET", "sudo sed -i '\$a%s root /usr/sbin/zpool scrub %s ' ".ZFS_FILE_CRON_SCRUB);
    define("ZFS_CMD_SCRUB_RM", "sudo sed -i '/ root \\/usr\\/sbin\\/zpool scrub %s /d' ".ZFS_FILE_CRON_SCRUB);
    define("ZFS_CMD_REPLICATE_SET", "sudo sed -i '\$a/%s root /usr/bin/systemctl start zfs-replicate@%s.service ' ".ZFS_FILE_CRON_REPLICATE);
    define("ZFS_CMD_REPLICATE_STATUS","sudo systemctl status zfs-replicate@%s.service");
    define("ZFS_CMD_REPLICATE_RM", "sudo sed -i '/ root /usr/bin/systemctl start zfs-replicate@%s.service /d' ".ZFS_FILE_CRON_REPLICATE);
    define("ZFS_CMD_GET_DISK_ID_PATH", "udevadm info -q all --name %s | grep 'S: disk/by-id/' | awk -F / '{print $3}'");

    define("ZFS_CMD_FILE", "sudo file -sL %s");

    define("ZFS_DIR_RUN", "/run/zfs");
    define("ZFS_DIR_RUN_SEND_CONF", ZFS_DIR_RUN."/send/conf");
    define("ZFS_DIR_RUN_SEND_PROGRESS", ZFS_DIR_RUN."/send/progress");
    define("ZFS_DIR_RUN_REPLICATE_PROGRESS", ZFS_DIR_RUN."/replicate/progress");
    define("ZFS_DIR_RUN_RECEIVE_CONF", ZFS_DIR_RUN."/receive/conf");
    define("ZFS_DIR_RUN_RECEIVE_PROGRESS", ZFS_DIR_RUN."/receive/progress");
?>
