var editpool_tasktimer = null;
var editpool_tasknamelist = [];

function zfseditpool_mission_alload() {
  clearTimeout(editpool_tasktimer);
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/wmi/',
      data: JSON.encode({
        "token": UToken,
        "cmd": 'zfsrep_mission_alload'
      }),
      type: "post",
      dataType: "json",
      contentType: 'application/json',
      timeout: 30000,
      success: function(res) {
        editpool_tasknamelist = [];
        if (res.err == 0) {
          var records = res.results.records || [];
          jQuery('#jv-editpoolrecvhost').empty();
          for (var i = 0; i < records.length; i++) {
            var tp_r = records[i];
            editpool_tasknamelist.push(tp_r.caption.toLowerCase());
            if ((edit_zpoolname != tp_r.pool) || (tp_r.action == 1 || tp_r.action == 3)) {
              continue;
            }
            var taskdom = zfsTemplateAppend('#jv-editpoolrecvhost', 'jvt-taskitem_editpool', 'jvt-taskitem_editpool-' + i);
            taskdom.find('.bdrtask-taskitem').data('taskinfo', tp_r);
            taskdom.find('.taskname').text(tp_r.caption || '--');
            taskdom.find('.dataset').text(tp_r.pool + '/' + tp_r.name);
            if (tp_r.host) {
              var path = tp_r.host + ':' + tp_r.port + '/' + tp_r.path;
              taskdom.find('.sendtask').text(path || '--');
            } else {
              taskdom.find('.sendtask').text(tp_r.path || '--');
            }


            var schedulestxt = [];
            if (tp_r.schedules.length) {
              for (var s = 0; s < tp_r.schedules.length; s++) {
                var t_s = tp_r.schedules[s];
                schedulestxt.push(zfseditpool_setSendTime(t_s));
              }
              taskdom.find('.schedule').html(schedulestxt[0]);
              var h = '';
              for (var j = 0; j < schedulestxt.length; j++) {
                h += '<li>' + schedulestxt[j] + '</li>';
              }
              taskdom.find('.jvc-sls').html(h);
              if (tp_r.schedules.length > 1) {
                taskdom.find('.schedulenub').text(tp_r.schedules.length).show();
              }

              taskdom.find('.schedulenub').on('mouseenter', function() {
                jQuery(this).parent().siblings('.schedulenublist').show();
              }).on('mouseleave', function() {
                jQuery(this).parent().siblings('.schedulenublist').hide();
              })

            } else {
              taskdom.find('.schedule').text('Nil');
              taskdom.find('.schedulenub').text(0).hide();
            }

            taskdom.find('.edit-taskicon').on('click', function() {
              var pnode = jQuery(this).closest('div.bdrtask-taskitem');
              var taskinfo = pnode.data('taskinfo');
              recvtaskFn_editpool(taskinfo, 'edit');
            });

            taskdom.find('.unas_icon_delete').on('click', function() {
              var pnode = jQuery(this).closest('div.bdrtask-taskitem');
              var taskinfo = pnode.data('taskinfo');
              unasConfirm({
                msg: UNAS._("Confirm to delete task") + '：' + taskinfo.caption + ' ?'
              }, function() {
                editpool_mission_remove(taskinfo.msnno);
              })
            });
          }
        }
        zfsTranslator('jv-editpoolrecvhost');
      },
      complete: function(xml) {
        resolve(xml);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        reject(XMLHttpRequest);
      }
    })
  }).then(function() {
    zfseditpool_updatetaskrate();
  })
}

function zfseditpool_updatetaskrate() {
  clearTimeout(editpool_tasktimer);
  jQuery.ajax({
    url: '/wmi/',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'zfsrep_mission_alload'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var taskdom = jQuery('#jv-editpoolrecvhost').children();
      if (res.err == 0) {
        var records = res.results.records || [];
        for (var j = 0; j < taskdom.length; j++) {
          var t_dom = jQuery(taskdom[j]).find('.bdrtask-taskitem');
          var taskinfo = t_dom.data('taskinfo');
          for (var i = 0; i < records.length; i++) {
            var t_s = records[i];
            if (t_s.caption == taskinfo.caption) {
              if (t_s.rate >= 0) {
                t_dom.find('.taskstate').text(UNAS._('##$@zfs@$##In Progress##$@zfs@$##'));
                t_dom.find('.taskstate').addClass('taskstate-0').removeClass('taskstate-2');
                t_dom.find('.tasknametitle').addClass('tasknametitle-0').removeClass('tasknametitle-1');
                t_dom.find('.edit-taskicon').addClass('layui-disabled');
                t_dom.find('.unas_icon_delete').addClass('layui-disabled');
                t_dom.find('.percent_txt').text(t_s.rate + '%');
                t_dom.find('.bar-w').css('width', t_s.rate + '%');
                t_dom.find('.jcv-speed').text(t_s.speed);
              } else {
                t_dom.find('.taskstate').text(UNAS._('##$@zfs@$##Completed##$@zfs@$##'));
                t_dom.find('.taskstate').addClass('taskstate-2').removeClass('taskstate-0');
                t_dom.find('.tasknametitle').addClass('tasknametitle-1').removeClass('tasknametitle-0');
                t_dom.find('.edit-taskicon').removeClass('layui-disabled');
                t_dom.find('.unas_icon_delete').removeClass('layui-disabled');
                if (t_s.finishedtime) {
                  t_dom.find('.percent_txt').text(t_s.finishedtime);
                } else {
                  t_dom.find('.percent_txt').text('');
                }
                t_dom.find('.bar-w').css('width', '0%');
                t_dom.find('.jcv-speed').text('--');
              }
            }
          }

        }


      }
    },
    complete: function(xml) {
      var taskdom = jQuery('#jv-editpoolrecvhost').children();
      var taskhosthidden = jQuery('#zfs_snapshot_replication_container').is(':hidden');
      if (taskdom.length && !taskhosthidden) {
        editpool_tasktimer = setTimeout(function() {
          zfseditpool_updatetaskrate();
        }, 2000);
      } else {
        clearTimeout(editpool_tasktimer);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function zfseditpool_setSendTime(time) {
  var h = time['hours'];
  var m = time['minutes'];
  var w_i = time['weeks'];
  var days = time['days'];
  var weekArray = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
  var week = weekArray[w_i];
  var timetext = '';
  if (w_i) {
    timetext = '<span>' + week + '</span>' + ' ' + addTimeZero_zfseditpool(h) + ':' + addTimeZero_zfseditpool(m);
  } else if (days) {
    timetext = '<span>Monthly</span>' + ' ' + days + '<span>st</span>' + ' ' + addTimeZero_zfseditpool(h) + ':' + addTimeZero_zfseditpool(m);
  } else {
    timetext = '<span>Daily</span>' + ' ' + addTimeZero_zfseditpool(h) + ':' + addTimeZero_zfseditpool(m);
  }
  return timetext;
}

function addTimeZero_zfseditpool(num) {
  return num >= 10 ? num : '0' + num;
}

function editpool_mission_remove(n) {
  jQuery.ajax({
    url: '/wmi/',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'zfsrep_mission_remove',
      "params": {
        msnno: n
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      zfseditpool_mission_alload();
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function recvtaskFn_editpool(info = '', type = '') {
  var title = UNAS._('##$@zfs@$##Create Recv task##$@zfs@$##');
  type && (title = UNAS._('##$@zfs@$##Edit Task##$@zfs@$##'));
  var createrecvtaskWin = new MUI.Modal({
    id: 'jv-createrecvtaskWindow',
    title: title,
    modal: true,
    modalOverlayClose: false,
    width: 800,
    height: 550,
    recvtask: {
      info: info,
      type: type
    },
    contentURL: '/apps/zfs/zfs_recvtask.html?v=0.0.1&',
    onClose: function() {
      jQuery('#laydate_box').remove();
      recv_reqstatus = 0;
    }
  });
}

(function() {
  zfseditpool_mission_alload();
})()
