var send_tiem = null;

function formatSize(bytes, decimalPoint) {
  if (bytes == 0) return '0 KB';
  var k = 1024,
    dm = decimalPoint || 2,
    sizes = ['KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB', 'BB'],
    i = Math.floor(Math.log(bytes) / Math.log(k));
  return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
}

function ImportPool(p) {
  jQuery('#zfs_manager_waiting_content').attr("style", "display: block");
  jQuery('#zfs_manager_waiting_logo').attr("style", "display: block");
  let data = {
    'cmd': 'zfs_zpool_import',
    "params": {
      "zpool": p
    }
  };

  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(data) {
      setTimeout(function() {
        getZPOOLsInfo("");
      }, 300);
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });

}

function unasConfirm(data, fn) {
  var alertWindow = new MUI.Modal({
    id: 'jv-alertWindow',
    title: UNAS._('Tips'),
    modal: true,
    modalOverlayClose: false,
    width: 400,
    height: 200,
    data: data,
    contentURL: '/apps/zfs/alert.html?v=0.0.1&'
  });
  alertWindow.callBack = function() {
    if (typeof fn == 'function') {
      fn();
    }
  };
}

function ExportPool(p) {

  unasConfirm({
    name: p,
    msg: UNAS._("Are you sure to export pool: ") + p
  }, function() {
    let data = {
      cmd: 'zfs_zpool_export',
      params: {
        "zpool": p
      }
    }
    jQuery('#zfs_manager_waiting_content').attr("style", "display: block");
    jQuery('#zfs_manager_waiting_logo').attr("style", "display: block");
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 30000,
      success: function(data) {
        setTimeout(function() {
          getZPOOLsInfo("");
        }, 300);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })

}

function getZPOOLsInfo(sel_zpool) {
  jQuery('#zfs_manager_waiting_content').attr("style", "display: block");
  jQuery('#zfs_manager_waiting_logo').attr("style", "display: block");
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode({
      "cmd": "zfs_zpools_info"
    }),
    timeout: 30000,
    dataType: "json",
    contentType: 'application/json',
    success: function(result) {
      let data = result.results;
      zpoolsinfo = result.results;
      jQuery('#CreateZpool').show();

      jQuery('#list_zfspool').html('');
      for (var i = 0; i < data.length; i++) {
        var zpool_size = data[i].size;
        var zpoolfree_size = data[i].free;

        var is_open = false;
        if ((i == 0) && (sel_zpool == "")) {
          is_open = true;
        } else if (sel_zpool == data[i].name) {
          is_open = true;
        }
        var clikfun = "";
        var zpool_top = "";
        if (data[i].state == 0) { //not imported
          zpool_top = '<dt class="' + ((is_open) ? "open" : "zfs_close") + '" id="zpool_dt_' + i + '">' +
            '<div class="open_button">' +
            '<a><span class="' + ((is_open) ? "close_img" : "open_img") + '" onclick="openCloseZpoolWindow(this,' + i + ');"></span></a>' +
            '</div>' +
            '<div class="date' + (data[i].free > 32 * 1024 ? "" : " createzpool_hover") + '">' +
            '<a title="' + '##$@zfs@$##Import##$@zfs@$##' + '" ' + 'onClick="ImportPool(' + "'" + data[i].name + "'" + ')"' + '><span class="createzfilesys_button_img"></span><span>' + '##$@zfs@$##Import##$@zfs@$##' + '</span></a>' +
            '</div>' +
            '<div class="title"><span style="margin-right:5px;">' + '##$@zfs@$##zPool##$@zfs@$##' + '</span><span>' + data[i].name + '</span><span class="size"> ( ' + formatSize(zpool_size) + ' / ' + formatSize(zpoolfree_size) + ' </span><span class="size">' + '##$@zfs@$##Free##$@zfs@$##' + '</span><span class="size">,   ' + data[i].health + ')</span> </div>' +
            '</dt>';
        } else {
          zpool_top = '<dt class="' + ((is_open) ? "open" : "zfs_close") + '" id="zpool_dt_' + i + '">' +
            '<div class="open_button">' +
            '<a><span class="' + ((is_open) ? "close_img" : "open_img") + '" onclick="openCloseZpoolWindow(this,' + i + ');"></span></a>' +
            '</div>' +
            '<div class="date ' + (data[i].zfilesyss.length > 0 ? "deletezpool_hover_disable" : "deletezpool_hover") + '">' +
            '<a ' + (data[i].zfilesyss.length > 0 ? "" : ('onClick="DeleteZpoolWindowFun(' + "'" + data[i].name + "'" + ')"')) + '><span class="' + (data[i].zfilesyss.length > 0 ? "delzpool_button_img_disable" : "delzpool_button_img") + '"></span><span class="deletePool">' + '##$@zfs@$##Delete Pool##$@zfs@$##' + '</span></a>' +
            '</div>' +
            '<div class="date">' +
            '<a onClick="ExportPool(' + "'" + data[i].name + "'" + ')" ><span class="export_button_img"></span><span>' + '##$@zfs@$##Export##$@zfs@$##' + '</span></a>' +
            '</div>' +
            '<div class="date' + (data[i].free > 32 * 1024 ? "" : " createzpool_hover_disable") + '">' +
            '<a title="' + (data[i].free < 33 * 1024 ? '##$@zfs@$##No Free Space##$@zfs@$##' : "") + '" ' + (data[i].free < 33 * 1024 ? "" : ('onClick="CreateZfilesysWindowFun(' + "'" + data[i].name + "','" + data[i].size + "','" + data[i].free + "'" + ')"')) + '><span class="' + (data[i].free > 32 * 1024 ? "createzfilesys_button_img" : "createzfilesys_button_img_disable") + '"></span><span>' + '##$@zfs@$##Create Volume##$@zfs@$##' + '</span></a>' +
            '</div>' +
            '<div class="date">' +
            '<a onClick="EditZpoolWindowFun(' + "'" + data[i].name + "','" + zpool_size + "','" + zpoolfree_size + "'" + ')" ><span class="editzpool_button_img"></span><span>' + '##$@zfs@$##Edit##$@zfs@$##' + '</span></a>' +
            '</div>' +
            '<div class="title"><span style="margin-right:5px;">' + '##$@zfs@$##zPool##$@zfs@$##' + '</span><span>' + data[i].name + '</span><span class="size"> ( ' + formatSize(zpool_size) + ' / ' + formatSize(zpoolfree_size) + ' </span><span class="size">' + '##$@zfs@$##Free##$@zfs@$##' + '</span><span class="size">,   ' + data[i].health + ')</span> </div>' +
            '</dt>';

        }
        var zpoolzfilesys_cont = "";
        var zfilesys_cont_act_sec = "";
        jQuery.each(data[i].zfilesyss, function(key, zfilesys) {
          var zfilesys_cont_head = "";
          var zfilesys_cont_percent = "";
          var zfilesys_cont_df = "";
          var zfilesys_cont_act = "";
          var snName = '';
          var zvolTitle = zfilesys.zfilesys ? 'Snapshot:' : 'Dataset:';
          var keystatusTs = '';
          var zt = "<span class='zt-0'>##$@zfs@$##Unmounted##$@zfs@$##</span>"
          zfilesys.snap = zfilesys.snap || [];
          var isSnap = false;
          if (zfilesys.snap.length) {
            isSnap = true;
          }
          if (zfilesys.keystatus) {
            keystatusTs = ',<span>##$@zfs@$##key loaded##$@zfs@$##)</span>';
          } else {
            keystatusTs = ',<span>##$@zfs@$##key unloaded##$@zfs@$##)</span>';
          }
          if (zfilesys.type == "volume") {
            zt = "<span class='zt-1 zt-1-on'></span>";;
            snName = zfilesys.name;
            zfilesys_cont_head = '<h3 class="unas-flex"><a class="unas_table_text" title="' + zfilesys.name + '"><span>##$@zfs@$##zVol:##$@zfs@$##</span> <span style="color:#057FEB;" >' + zfilesys.name + '</span></a></h3>';
          } else {

            if (zfilesys.mounted) {
              zt = "<span class='zt-1'>##$@zfs@$##Mounted##$@zfs@$##</span>";
            }
            snName = zfilesys.zfilesys ? (zfilesys.zfilesys + '@' + zfilesys.name) : zfilesys.name;

            zfilesys_cont_head = '<h3 class="unas-flex"><a class="unas_table_text" title="' + snName + '"><span>' + zvolTitle + '</span> <span style="color:#057FEB;" >' + snName + '</span></a></h3>';
          }
          if ((zfilesys.attr) && (zfilesys.fstype != "volume") && ((zfilesys.encryption == "off") || ((zfilesys.encryption != "off") && zfilesys.mounted))) {
            zfilesys_cont_percent = '<div class="volume_percentage">' +
              '<ul>' +
              '<li class="percent_box" id="percentagebox' + zfilesys.zpool + "-" + zfilesys.name + '" style="" title="' + parseInt(zfilesys.used * 100 / zfilesys.size) + '%">' +
              '<img id="percentageimg' + zfilesys.zpool + "-" + zfilesys.name + '" src="/apps/zfs/images/percent.png?v=0.0.1&"  width="' + parseInt(zfilesys.used * 100 / zfilesys.size) + '%"/>' +
              '</li><li></li></ul>' +
              '</div>';
          } else {
            zfilesys_cont_percent = '<div class="volume_percentage">' +
              '<ul>' +
              '<li class="percent_box_null" id="percentagebox' + zfilesys.zpool + "-" + zfilesys.name + '" title="">' +
              '<img id="percentageimg' + zfilesys.zpool + "-" + zfilesys.name + '" src="/apps/zfs/images/percent_null.png?v=0.0.1&" height="26px" width="210px"/>' +
              '</li><li></li></ul>' +
              '</div>';
          }

          var zfilesys_size = zfilesys.size;
          if (!zfilesys.mounted && (zfilesys.type != "volume")) {
            zfilesys_cont_df = '<div class="availsizetxt"><span id="zfilesysinfo_availsize' + zfilesys.zpool + "-" + zfilesys.name + '">' + '##$@zfs@$##Unmounted##$@zfs@$##' + '</span><span id="zfilesysinfo_avail' + zfilesys.zpool + "-" + zfilesys.name + '"></span>,&nbsp;<span>' + '##$@zfs@$##Total##$@zfs@$##' + '</span>' + '<span>' + formatSize(zfilesys_size) + '</span></div>';
          } else if (zfilesys.type == "volume") {
            zfilesys_cont_df = '<div class="availsizetxt"><span>' + '##$@zfs@$##Size##$@zfs@$##' + '</span>' + ':' + '<span>' + formatSize(zfilesys_size) + '</span></div>';
          } else if (zfilesys.mounted) {
            zfilesys_cont_df = '<div class="availsizetxt"><span id="zfilesysinfo_availsize' + zfilesys.zpool + "-" + zfilesys.name + '">' + formatSize(zfilesys.available || 0) + '</span>' + '<span id="zfilesysinfo_avail' + zfilesys.zpool + "-" + zfilesys.name + '">' + '##$@zfs@$##Available##$@zfs@$##' + '</span>,&nbsp;<span>' + '##$@zfs@$##Total##$@zfs@$##' + '</span>' + '<span>' + formatSize(zfilesys_size) + '</span></div>';
          }


          zfilesys_cont_act = '<div class="volume_action"><p class="unas-flex"><a class="zPproperty" onClick="EditZfilesysWindowFun(' + "'" + zfilesys.zpool + "','" + snName + "','" + data[i].free + "','" + zfilesys.snapshot + "'" + ')" title="' + '##$@zfs@$##View and Edit Volume Property##$@zfs@$##' + '" >' + '##$@zfs@$##Property##$@zfs@$##' + '</a>';
          if (zfilesys.type != "volume") {
            if (zfilesys.mounted && !zfilesys.snapshot) {
              zfilesys_cont_act += '<a class="zfgx"></a>';
              zfilesys_cont_act += '<a class="zPsnapshot" title="' + '##$@zfs@$##Snapshot##$@zfs@$##' + '" onClick="ZfsSnapshotWindowFun(' + "'" + zfilesys.zpool + "','" + zfilesys.name + "','" + zfilesys.encryption + "'" + ')">' + '##$@zfs@$##Snapshot##$@zfs@$##' + '</a>';
              zfilesys_cont_act += '<a class="zfgx"></a>';
            }
            if (zfilesys.mounted) {
              zfilesys_cont_act += '<a class="zPmounted" id="mountzfilesys' + zfilesys.zpool + '-' + zfilesys.name + '" onClick="umountZfilesys(' + "'" + zfilesys.zpool + "','" + snName + "','" + zfilesys.encryption + "','" + zfilesys.snapshot + "'" + ')" class="' + "umount" + '">' + "##$@zfs@$##Unmount##$@zfs@$##" + '</a>';
            } else {
              zfilesys_cont_act += '<a class="zfgx"></a>';
              zfilesys_cont_act += '<a id="mountzfilesys' + zfilesys.zpool + '-' + zfilesys.name + '" onClick="mountZfilesys(' + "'" + zfilesys.zpool + "','" + snName + "','" + zfilesys.encryption + "','" + zvolTitle + "','" + zfilesys.keystatus + "'" + ')" class="' + "zMount" + '">' + "##$@zfs@$##Mount##$@zfs@$##" + '</a>';
              zfilesys_cont_act += '<a class="zfgx"></a>';
            }

            if (zfilesys.mounted) {
              // zfilesys_cont_act += "##$@zfs@$##Mounted##$@zfs@$##";
            } else if (zfilesys.snapshot) {
              zfilesys_cont_act += "";
            } else {
              zfilesys_cont_act += '<a id="deletezfilesys' + zfilesys.zpool + '-' + zfilesys.name + '" class="zDelete ' + '" ofsnap="' + ((zfilesys.snapshot) ? "yes" : "no") + '" type="' + zfilesys.type + '" onClick="deleteZfilesys(' + "'" + zfilesys.zpool + "','" + snName + "','" + zfilesys.encryption + "','" + isSnap + "'" + ');">';
              zfilesys_cont_act += "##$@zfs@$##Delete##$@zfs@$##";
            }
            zfilesys_cont_act += '</a>';
          } else {
            zfilesys_cont_act += '<a class="zfgx"></a>';
            zfilesys_cont_act += '<a class="zPsnapshot" title="##$@zfs@$##Snapshot##$@zfs@$##"  onClick="ZfsSnapshotWindowFun(' + "'" + zfilesys.zpool + "','" + zfilesys.name + "','" + zfilesys.encryption + "'" + ')">' + '##$@zfs@$##Snapshot##$@zfs@$##' + '</a>';
            zfilesys_cont_act += '<a class="zfgx"></a>';
            zfilesys_cont_act += '<a id="deletezfilesys' + zfilesys.zpool + '-' + zfilesys.name + '" class="' + (((zfilesys.attr) || (zfilesys.snapshot)) ? "zfilesys_delete_none" : "zDelete") + '" ofsnap="' + ((zfilesys.snapshot) ? "yes" : "no") + '" type="' + zfilesys.type + '" onClick="deleteZfilesys(' + "'" + zfilesys.zpool + "','" + zfilesys.name + "'" + ');">';
            if (zfilesys.attr) {
              zfilesys_cont_act += "##$@zfs@$##Used##$@zfs@$##";
            } else if (zfilesys.snapshot) {
              zfilesys_cont_act += "";
            } else {
              zfilesys_cont_act += "##$@zfs@$##Delete##$@zfs@$##";
            }
            zfilesys_cont_act += '</a>';
          }

          zfilesys_cont_act += '</p>';

          zfilesys_cont_act_sec = '<p>';
          if (zfilesys.encryption == "off")
            zfilesys_cont_act_sec += '</p></div>';

          zpoolzfilesys_cont += '<dl >' +
            zfilesys_cont_head +
            '<div class="samp1">' +
            zfilesys_cont_df +
            zfilesys_cont_percent +
            zt +
            ((zfilesys.encryption != "off") ? '<span>(##$@zfs@$##Encrypted##$@zfs@$##</span>' + keystatusTs + '' : '') +
            '</div>' +
            zfilesys_cont_act +
            zfilesys_cont_act_sec +
            // '<div>' + ((zfilesys.encryption != "off")?'<span>(##$@zfs@$##Encrypted##$@zfs@$##</span>'+keystatusTs+'':'') +'</div>'+
            '</dl>';

        });

        var zfilesys_content = '<dd id="zpool_dd_' + i + '" style="display:' + (is_open ? "block" : "none") + '"><div class="content"><ul><li>' +
          zpoolzfilesys_cont +
          '<div class="clearzpoolcontent"></div>' +
          '</li></ul></div></dd>';;
        var zpool_info = zpool_top + zfilesys_content;
        jQuery('#list_zfspool').append(zpool_info);
      }
      if (data.length < 1) {
        var zpool_top = '<dt class="open">' +
          '<div class="title"><span style="margin-right:5px;">' + '##$@zfs@$##No Volume Group##$@zfs@$##' + '</span></div>' +
          '</dt>';
        var zfilesys_content = '<dd><div class="content"><ul><li>' +
          '<div class="clearzpoolcontent"></div>' +
          '</li></ul></div></dd>';;
        var zpool_info = zpool_top + zfilesys_content;
        jQuery('#list_zfspool').append(zpool_info);

      }
      zfsTranslator('zfs_manager_zpool_list');
      jQuery('#zfs_manager_waiting_content').attr("style", "display: none");
      jQuery('#zfs_manager_waiting_logo').attr("style", "display: none");
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
      jQuery('#zfs_manager_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_waiting_logo').attr("style", "display:none");
    }
  });
}

function umountZfilesys(zpool, zfilesys, crypt, isSnapshot) {
  var UmountZfilesysW = new MUI.Modal({
    id: 'UmountZfilesysWindow',
    title: UNAS._('##$@zfs@$##Unmount Dataset/zVol##$@zfs@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 400,
    height: 220,
    contentURL: '/apps/zfs/umount_zfilesys.html?v=0.0.1&zpoolname=' + zpool + '&zfilesysname=' + zfilesys + '&crypt=' + crypt + '&isSnapshot=' + isSnapshot
  });
  UmountZfilesysW.ProcessUmountZfilesys = function() {
    getZPOOLsInfo(zpool);
  }
}

function mountZfilesys(zpool, zfilesys, crypt, type, keystatus) {
  if (true) {
    var MountZfilesysW = new MUI.Modal({
      id: 'MountZfilesysWindow',
      title: UNAS._('##$@zfs@$##Mount Dataset/zVol##$@zfs@$##'),
      modal: true,
      modalOverlayClose: false,
      width: 400,
      height: 220,
      contentURL: '/apps/zfs/mount_zfilesys.html?v=0.0.1&zpoolname=' + zpool + '&zfilesysname=' + zfilesys + '&crypt=' + crypt + '&zvolTitle=' + type.split(':')[0] + '&keystatus=' + keystatus
    });
    MountZfilesysW.ProcessMountZfilesys = function() {
      getZPOOLsInfo(zpool);
    }
  }
}

function openCloseZpoolWindow(e, i) {
  var class_name = jQuery(e).attr("class");
  if (class_name == "close_img") {
    jQuery("#zpool_dt_" + i).attr("class", "zfs_close");
    jQuery(e).attr("class", "open_img");
    jQuery("#zpool_dd_" + i).attr("style", "display:none");
  } else {
    jQuery("#zpool_dt_" + i).attr("class", "open");
    jQuery(e).attr("class", "close_img");
    jQuery("#zpool_dd_" + i).attr("style", "display:block");
  }
}

function deleteZfilesys(zpool, zfilesys, crypt, isSnap) {
  var zfilesystype = "";
  var DeleteZfilesysW = new MUI.Modal({
    id: 'DeleteZfilesysWindow',
    title: UNAS._('##$@zfs@$##Delete Volume##$@zfs@$##'),
    modal: true,
    width: 400,
    height: 220,
    modalOverlayClose: false,
    contentURL: '/apps/zfs/delete_zfilesys.html?v=0.0.1&zpoolname=' + zpool + '&zfilesysname=' + zfilesys + '&zfilesystype=' + zfilesystype + '&crypt=' + crypt + '&isSnap=' + isSnap
  });
  DeleteZfilesysW.ProcessDeleteZfilesys = function() {
    getZPOOLsInfo(zpool);
  }

}

function CreateZpoolWindowFun() {
  var CreateZPOOLW = new MUI.Modal({
    id: 'CreateZpoolWindow',
    title: UNAS._('##$@zfs@$##Create zPool##$@zfs@$##'),
    modal: true,
    width: 1000,
    height: 480,
    modalOverlayClose: false,
    contentURL: '/apps/zfs/create_zpool.html?v=0.0.1&'
  });
  CreateZPOOLW.ProcessCreateZpool = function() {
    getZPOOLsInfo("");
  }
}

function ImportZpoolWindowFun() {
  var ImportZPOOLW = new MUI.Modal({
    id: 'ImportZpoolWindow',
    title: UNAS._('##$@zfs@$##Import##$@zfs@$##'),
    modal: true,
    width: 700,
    height: 480,
    modalOverlayClose: false,
    contentURL: '/apps/zfs/import_zpool.html?v=0.0.1&'
  });
  CreateZPOOLW.ProcessCreateZpool = function() {
    getZPOOLsInfo("");
  }
}

function EditZpoolWindowFun(zpoolname, zpoolsize, zpoolfreesize) {
  var EditZpoolW = new MUI.Modal({
    id: 'EditZpoolWindow',
    title: UNAS._('##$@zfs@$##Edit Volume Group##$@zfs@$##'),
    modal: true,
    width: 886,
    height: 540,
    resizable: true,
    resizeLimit: { 'x': [700, 2000], 'y': [500, 3000] },
    evalScripts: true,
    modalOverlayClose: false,
    contentURL: '/apps/zfs/edit_zpool.html?v=0.0.1&zpoolname=' + zpoolname + '&zpoolsize=' + zpoolsize + "&zpoolfreesize=" + zpoolfreesize
  });
  EditZpoolW.ProcessEditZpool = function() {
    getZPOOLsInfo(zpoolname);
  }
}

function DeleteZpoolWindowFun(zpoolname) {
  var DeleteZpoolW = new MUI.Modal({
    id: 'DeleteZpoolWindow',
    title: UNAS._('##$@zfs@$##Delete Volume Group##$@zfs@$##'),
    modal: true,
    width: 400,
    height: 220,
    modalOverlayClose: false,
    contentURL: '/apps/zfs/delete_zpool.html?v=0.0.1&zpoolname=' + zpoolname
  });
  DeleteZpoolW.ProcessDeleteZpool = function() {
    getZPOOLsInfo(zpoolname);
  }
}

function CreateZfilesysWindowFun(zpoolname, zpoolsize, zpoolfreesize) {
  var CreateZfilesysW = new MUI.Modal({
    id: 'CreateZfilesysWindow',
    title: UNAS._('##$@zfs@$##Create Volume##$@zfs@$##'),
    modal: true,
    width: 650,
    height: 510,
    modalOverlayClose: false,
    contentURL: '/apps/zfs/create_zfilesys.html?v=0.0.1&zpoolname=' + zpoolname + '&zpoolsize=' + zpoolsize + "&zpoolfreesize=" + zpoolfreesize
  });
  CreateZfilesysW.ProcessCreateZfilesys = function() {
    getZPOOLsInfo(zpoolname);
  }
}

function EditZfilesysWindowFun(zpoolname, zfilesysname, zpoolfreesize, isSnapshot) {
  var EditZfilesysW = new MUI.Modal({
    id: 'EditZfilesysWindow',
    title: UNAS._('##$@zfs@$##Edit Volume##$@zfs@$##'),
    modal: true,
    width: 650,
    height: 460,
    modalOverlayClose: false,
    contentURL: '/apps/zfs/edit_zfilesys.html?v=0.0.1&zpoolname=' + zpoolname + '&zfilesysname=' + zfilesysname + "&zpoolfreesize=" + zpoolfreesize + "&isSnapshot=" + isSnapshot
  });
  EditZfilesysW.ProcessEditZfilesys = function() {
    getZPOOLsInfo(zpoolname);
  }
}

function ZfsSnapshotWindowFun(zpoolname, zfilesysname, crypt) {
  var SnapshotW = new MUI.Modal({
    id: 'SnapshotWindow',
    title: window.top.UNAS._('##$@zfs@$##Snapshot Manager##$@zfs@$##'),
    modal: true,
    width: 930,
    height: 550,
    modalOverlayClose: false,
    onClose: function() {
      clearTimeout(send_tiem);
    },
    contentURL: '/apps/zfs/snapshot.html?v=0.0.1&zpoolname=' + zpoolname + '&zfilesysname=' + zfilesysname + '&crypt=' + crypt
  });
  SnapshotW.ProcessSnapshot = function() {
    getZPOOLsInfo(zpoolname);
  }
}

function validateInput(event) {
  var input = event;
  var regex = /^[a-zA-Z][a-zA-Z0-9]*$/;
  if (!regex.test(input.value)) {
      // 输入不符合规则，阻止输入并移除错误输入
      input.value = input.value.replace(/[^a-zA-Z0-9]/g, '');
      // 如果开头不是字母，则移除开头字符
      if (!/^[a-zA-Z]/.test(input.value)) {
          input.value = '';
      }
    }
}

(function() {
  getZPOOLsInfo("");
  jQuery('#CreateZpool').click(function() {
    CreateZpoolWindowFun();
  });
  jQuery('#ImportZpool').click(function() {
    ImportZpoolWindowFun();
  });
  jQuery("#zfs_manager_zpool_list").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
})();
