function zfsrep_log_alload() {
  let data = {
    cmd: 'zfsrep_log_alload',
    token: UToken
  }

  jQuery.ajax({
    url: "/wmi/",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        jQuery('#jv-bdrloghost').empty();
        var records = res.results.records || [];
        for (var i = 0; i < records.length; i++) {
          var t_p = records[i];
          var logdom = zfsTemplateAppend('#jv-bdrloghost', 'jvt-logitem', 'jvt-logitem-' + i);
          logdom.find('.logname').text(t_p.caption || '--');
          logdom.find('.jvc-from').text(t_p.from || '--');
          logdom.find('.logtime').text(t_p.eventtime || '--');
          logdom.find('.jvc-to').text(t_p.to || '--');
          if (t_p.action == 1 || t_p.action == 3) {
            logdom.find('.jvc-action').text('Send');
          } else {
            logdom.find('.jvc-action').text('Recv');
          }

          logdom.find('.logstate').addClass('log-State-' + (t_p.result || 0))
          var c = t_p.result ? '##$@zfs@$##Completed##$@zfs@$##' : '##$@zfszfilesyscreate@$##Failed##$@zfszfilesyscreate@$##'
          logdom.find('.logstate').html(c);
        }
      }
      if (jQuery('#jv-bdrloghost tbody').children().length) {
        jQuery('#jv-bdrlogcancelbtn').removeClass('layui-disabled');
      } else {
        jQuery('#jv-bdrlogcancelbtn').addClass('layui-disabled');
      }
      zfsTranslator('jv-bdrloghost');
    },
    complete: function() {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function zfsrep_log_clear() {
  let data = {
    cmd: 'zfsrep_log_clear',
    token: UToken
  }

  jQuery.ajax({
    url: "/wmi/",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        zfsrep_log_alload();
      }
    },
    complete: function() {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

jQuery(document).ready(function() {
  zfsrep_log_alload();
  jQuery('#jv-selalllog').on('click', function() {
    var s_len = jQuery('#jv-bdrloghost').children().length;
    if (this.checked && s_len) {
      jQuery('#jv-bdrloghost input[type="checkbox"]').prop('checked', true);
      jQuery('#jv-bdrlogcancelbtn').removeClass('layui-disabled');
    } else {
      jQuery('#jv-bdrloghost input[type="checkbox"]').prop('checked', false);
      jQuery('#jv-bdrlogcancelbtn').addClass('layui-disabled');
    }
  })

  jQuery('#jv-searchbdrlog').bind('input propertychange', function(e) {
    var v = jQuery(this).val();
    jQuery('#jv-bdrloghost tr').hide().filter(":contains('" + v + "')").show();
  });

  jQuery('#jv-bdrlogcancelbtn').click(function() {

    unasConfirm({
      msg: UNAS._("Are you sure to delete all logs?")
    }, function() {
      zfsrep_log_clear();
    })

  })

})
