var zfssnapshot_tasktimer = null;
var zfssnapshot_tasknamelist = [];

function zfssnapshot_mission_alload() {
  clearTimeout(zfssnapshot_tasktimer);
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/wmi/',
      data: JSON.encode({
        "token": UToken,
        "cmd": 'zfsrep_mission_alload'
      }),
      type: "post",
      dataType: "json",
      contentType: 'application/json',
      timeout: 30000,
      success: function(res) {

        zfssnapshot_tasknamelist = [];
        if (res.err == 0) {
          var records = res.results.records || [];
          jQuery('#jv-replications_list').empty();
          for (var i = 0; i < records.length; i++) {
            var tp_r = records[i];
            zfssnapshot_tasknamelist.push(tp_r.caption.toLowerCase());

            if ((snapshot_zfilesysname != tp_r.name) || (tp_r.action == 2 || tp_r.action == 4)) {
              continue;
            }
            var taskdom = zfsTemplateAppend('#jv-replications_list', 'jvt-taskitem_snapshot', 'jvt-taskitem_snapshot-' + i);
            taskdom.find('.bdrtask-taskitem').data('taskinfo', tp_r);
            taskdom.find('.taskname').text(tp_r.caption || '--');
            taskdom.find('.dataset').text(tp_r.pool + '/' + tp_r.name);
            if (tp_r.host) {
              var path = tp_r.host + ':' + tp_r.port + '/' + tp_r.path;
              taskdom.find('.sendtask').text(path || '--');
            } else {
              taskdom.find('.sendtask').text(tp_r.path || '--');
            }
            var schedulestxt = [];
            if (tp_r.schedules.length) {
              for (var s = 0; s < tp_r.schedules.length; s++) {
                var t_s = tp_r.schedules[s];
                schedulestxt.push(zfssnapshot_setSendTime(t_s));
              }
              taskdom.find('.schedule').html(schedulestxt[0]);
              var h = '';
              for (var j = 0; j < schedulestxt.length; j++) {
                h += '<li>' + schedulestxt[j] + '</li>';
              }
              taskdom.find('.jvc-sls').html(h);
              if (tp_r.schedules.length > 1) {
                taskdom.find('.schedulenub').text(tp_r.schedules.length).show();
              }

              taskdom.find('.schedulenub').on('mouseenter', function() {
                jQuery(this).parent().siblings('.schedulenublist').show();
              }).on('mouseleave', function() {
                jQuery(this).parent().siblings('.schedulenublist').hide();
              })

            } else {
              taskdom.find('.schedule').text('Nil');
              taskdom.find('.schedulenub').text(0).hide();
            }

            taskdom.find('.edit-taskicon').on('click', function() {
              var pnode = jQuery(this).closest('div.bdrtask-taskitem');
              var taskinfo = pnode.data('taskinfo');
              createTaskWin(taskinfo, 'edit');
            });

            taskdom.find('.unas_icon_delete').on('click', function() {
              var pnode = jQuery(this).closest('div.bdrtask-taskitem');
              var taskinfo = pnode.data('taskinfo');
              unasConfirm({
                msg: UNAS._("Confirm to delete task") + '：' + taskinfo.caption + ' ?'
              }, function() {
                zfssnapshot_mission_remove(taskinfo.msnno);
              })
            });
          }
        }
        zfsTranslator('jv-replications_list');
      },
      complete: function(xml) {
        resolve(xml);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        reject(XMLHttpRequest);
      }
    })
  }).then(function() {
    zfssnapshot_updatetaskrate();
  })
}

function zfssnapshot_updatetaskrate() {
  clearTimeout(zfssnapshot_tasktimer);
  jQuery.ajax({
    url: '/wmi/',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'zfsrep_mission_alload'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var taskdom = jQuery('#jv-replications_list').children();
      if (res.err == 0) {
        var records = res.results.records || [];
        for (var j = 0; j < taskdom.length; j++) {
          var t_dom = jQuery(taskdom[j]).find('.bdrtask-taskitem');
          var taskinfo = t_dom.data('taskinfo');
          for (var i = 0; i < records.length; i++) {
            var t_s = records[i];
            if (t_s.caption == taskinfo.caption) {
              if (t_s.rate >= 0) {
                t_dom.find('.taskstate').text(UNAS._('##$@zfs@$##In Progress##$@zfs@$##'));
                t_dom.find('.taskstate').addClass('taskstate-0').removeClass('taskstate-2');
                t_dom.find('.tasknametitle').addClass('tasknametitle-0').removeClass('tasknametitle-1');
                t_dom.find('.edit-taskicon').addClass('layui-disabled');
                t_dom.find('.unas_icon_delete').addClass('layui-disabled');
                t_dom.find('.percent_txt').text(t_s.rate + '%');
                t_dom.find('.bar-w').css('width', t_s.rate + '%');
                t_dom.find('.jcv-speed').text(t_s.speed);
              } else {
                t_dom.find('.taskstate').text(UNAS._('##$@zfs@$##Completed##$@zfs@$##'));
                t_dom.find('.taskstate').addClass('taskstate-2').removeClass('taskstate-0');
                t_dom.find('.tasknametitle').addClass('tasknametitle-1').removeClass('tasknametitle-0');
                t_dom.find('.edit-taskicon').removeClass('layui-disabled');
                t_dom.find('.unas_icon_delete').removeClass('layui-disabled');
                if (t_s.finishedtime) {
                  t_dom.find('.percent_txt').text(t_s.finishedtime);
                } else {
                  t_dom.find('.percent_txt').text('');
                }
                t_dom.find('.bar-w').css('width', '0%');
                t_dom.find('.jcv-speed').text('--');
              }
            }
          }

        }


      }
    },
    complete: function(xml) {
      var taskdom = jQuery('#jv-replications_list').children();
      var taskhosthidden = jQuery('#zfs_snapshot_replication_container').is(':hidden');
      if (taskdom.length && !taskhosthidden) {
        zfssnapshot_tasktimer = setTimeout(function() {
          zfssnapshot_updatetaskrate();
        }, 2000);
      } else {
        clearTimeout(zfssnapshot_tasktimer);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function zfssnapshot_mission_remove(n) {
  jQuery.ajax({
    url: '/wmi/',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'zfsrep_mission_remove',
      "params": {
        msnno: n
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      zfssnapshot_mission_alload();
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function zfssnapshot_setSendTime(time) {
  var h = time['hours'];
  var m = time['minutes'];
  var w_i = time['weeks'];
  var days = time['days'];
  var weekArray = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
  var week = weekArray[w_i];
  var timetext = '';
  if (w_i) {
    timetext = '<span>' + week + '</span>' + ' ' + addTimeZero_zfssnapshot(h) + ':' + addTimeZero_zfssnapshot(m);
  } else if (days) {
    timetext = '<span>Monthly</span>' + ' ' + days + '<span>st</span>' + ' ' + addTimeZero_zfssnapshot(h) + ':' + addTimeZero_zfssnapshot(m);
  } else {
    timetext = '<span>Daily</span>' + ' ' + addTimeZero_zfssnapshot(h) + ':' + addTimeZero_zfssnapshot(m);
  }
  return timetext;
}

function addTimeZero_zfssnapshot(num) {
  return num >= 10 ? num : '0' + num;
}
