<?php

require_once("/unas/apps/zfs/includes/settings.php");

$name = $argv[1];

function main(){
    global $name;
    if(file_exists(ZFS_FILE_REPLICATION)){
        $replicationTasksJson = json_decode(file_get_contents(ZFS_FILE_REPLICATION), true);
        if (isset($replicationTasksJson[$name])){
            $job_set = $replicationTasksJson[$name];

            $data_set = $job_set["dataset"];
            $time = date('Y-m-d_His');
            $snap_name = "$data_set@replicate-$time";
            $sendto = $job_set["SendToDir"];
            $targetName = str_replace('/', '_', $snap_name);

            //take a snapshot.
            $snap_cmd = "zfs snapshot $snap_name";
            exec($snap_cmd, $output, $ret);

            if (!is_dir(ZFS_DIR_RUN_REPLICATE_PROGRESS)) {
                mkdir(ZFS_DIR_RUN_REPLICATE_PROGRESS, 0755, true);
            }

            $progress_file = ZFS_DIR_RUN_REPLICATE_PROGRESS."/$name";
            $size_cmd = "zfs send -Pn $snap_name | grep -w ^size | awk '{print $2}'";
            $size = exec($size_cmd);
            file_put_contents($progress_file, $size.PHP_EOL);
            $send_cmd = "zfs send $snap_name | pv -btn > '$sendto/$targetName' 2>> $progress_file";

            exec($send_cmd);

            $clean_cmd = "zfs destroy $snap_name";
            exec($clean_cmd);
            unlink($progress_file);
        }
    }
}

main();
