<?php

require_once("/unas/apps/zfs/includes/settings.php");

$name = $argv[1];

function main(){
    global $name;
    $conf_file = ZFS_DIR_RUN_SEND_CONF."/$name";
    if(file_exists($conf_file)){
        $job_set = json_decode(file_get_contents($conf_file), true);

        switch ($job_set["type"]){
            case "local":
                $data_set = $job_set["dataset"];
                $sendto = $job_set["sendto"];
                $targetName =  str_replace('/', '_', $data_set);

                # Check and create snapshot
                $cmd = "zfs list -t snapshot $data_set || zfs create $data_set";
                exec($cmd);

                if (!is_dir(ZFS_DIR_RUN_SEND_PROGRESS)) {
                    mkdir(ZFS_DIR_RUN_SEND_PROGRESS, 0755, true);
                }

                $progress_file = ZFS_DIR_RUN_SEND_PROGRESS."/$name";
                $size_cmd = "zfs send -Pn $data_set | grep -w ^size | awk '{print $2}'";
                $size = exec($size_cmd);
                file_put_contents($progress_file, $size.PHP_EOL);
                $send_cmd = "zfs send $data_set | pv -btn > '$sendto/$targetName' 2>> $progress_file";
                exec($send_cmd);
                unlink($progress_file);
            default:
                break;
        }
        unlink($conf_file);
    }
}

main();
